#ifndef ARCH_OFF_H
#define ARCH_OFF_H
/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/include/arch_off.h $ 
* $Author: saa $ 
* $Revision: /main/3 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:  Specific interface to DSP archtecture-specific features
*
* Notes:     "arch" local offsets 
*
******************************************************************************/


#include "arch.h"


#ifdef __cplusplus
extern "C" {
#endif


enum arch_I0_offsets {
#if 0
      /* Sys */
    archoff_Sys_ControlReg = (int) ( &((arch_sIO*)0)->Sys.ControlReg ),
    archoff_Sys_StatusReg = (int) ( &((arch_sIO*)0)->Sys.StatusReg ),
    archoff_Sys_MostSignificantHalfJTAGIDReg = (int) ( &((arch_sIO*)0)->Sys.MostSignificantHalfJTAGIDReg ),
    archoff_Sys_LeastSignificantHalfJTAGIDReg = (int) ( &((arch_sIO*)0)->Sys.LeastSignificantHalfJTAGIDReg ),
    archoff_Sys_TestReg = (int) ( &((arch_sIO*)0)->Sys.TestReg[0] ),
#endif    
     /* Semi */
    archoff_Semi_BaseAddressReg0 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg0 ),
    archoff_Semi_BaseAddressReg1 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg1 ),
    archoff_Semi_BaseAddressReg2 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg2 ),
    archoff_Semi_BaseAddressReg3 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg3 ),    
    archoff_Semi_BaseAddressReg4 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg4 ),
    archoff_Semi_BaseAddressReg5 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg5 ),
    archoff_Semi_BaseAddressReg6 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg6 ),    
    archoff_Semi_BaseAddressReg7 = (int) ( &((arch_sIO*)0)->Semi.BaseAddressReg7 ),
    archoff_Semi_OptionReg0 = (int) ( &((arch_sIO*)0)->Semi.OptionReg0 ),
    archoff_Semi_OptionReg1 = (int) ( &((arch_sIO*)0)->Semi.OptionReg1 ),
    archoff_Semi_OptionReg2 = (int) ( &((arch_sIO*)0)->Semi.OptionReg2 ),
    archoff_Semi_OptionReg3 = (int) ( &((arch_sIO*)0)->Semi.OptionReg3 ),
    archoff_Semi_OptionReg4 = (int) ( &((arch_sIO*)0)->Semi.OptionReg4 ),
    archoff_Semi_OptionReg5 = (int) ( &((arch_sIO*)0)->Semi.OptionReg5 ),
    archoff_Semi_OptionReg6 = (int) ( &((arch_sIO*)0)->Semi.OptionReg6 ),
    archoff_Semi_OptionReg7 = (int) ( &((arch_sIO*)0)->Semi.OptionReg7 ),
    archoff_Semi_ControlReg = (int) ( &((arch_sIO*)0)->Semi.ControlReg ),
        /* timers */

    archoff_TimerA0 = (int) ( &((arch_sIO*)0)->TimerA.Channel0 ),        
    archoff_TimerA0_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerA.Channel0.CompareReg1 ),
    archoff_TimerA0_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerA.Channel0.CompareReg2 ),
    archoff_TimerA0_CaptureReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.CaptureReg ),
    archoff_TimerA0_LoadReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.LoadReg ),
    archoff_TimerA0_HoldReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.HoldReg ),
    archoff_TimerA0_CounterReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.CounterReg ),
    archoff_TimerA0_ControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.ControlReg ),
    archoff_TimerA0_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel0.StatusControlReg ),

    archoff_TimerA1 = (int) ( &((arch_sIO*)0)->TimerA.Channel1 ),
    archoff_TimerA1_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerA.Channel1.CompareReg1 ),
    archoff_TimerA1_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerA.Channel1.CompareReg2 ),
    archoff_TimerA1_CaptureReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.CaptureReg ),
    archoff_TimerA1_LoadReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.LoadReg ),
    archoff_TimerA1_HoldReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.HoldReg ),
    archoff_TimerA1_CounterReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.CounterReg ),
    archoff_TimerA1_ControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.ControlReg ),
    archoff_TimerA1_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel1.StatusControlReg ),

    archoff_TimerA2 = (int) ( &((arch_sIO*)0)->TimerA.Channel2 ),
    archoff_TimerA2_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerA.Channel2.CompareReg1 ),
    archoff_TimerA2_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerA.Channel2.CompareReg2 ),
    archoff_TimerA2_CaptureReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.CaptureReg ),
    archoff_TimerA2_LoadReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.LoadReg ),
    archoff_TimerA2_HoldReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.HoldReg ),
    archoff_TimerA2_CounterReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.CounterReg ),
    archoff_TimerA2_ControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.ControlReg ),
    archoff_TimerA2_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel2.StatusControlReg ),

    archoff_TimerA3 = (int) ( &((arch_sIO*)0)->TimerA.Channel3 ),
    archoff_TimerA3_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerA.Channel3.CompareReg1 ),
    archoff_TimerA3_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerA.Channel3.CompareReg2 ),
    archoff_TimerA3_CaptureReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.CaptureReg ),
    archoff_TimerA3_LoadReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.LoadReg ),
    archoff_TimerA3_HoldReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.HoldReg ),
    archoff_TimerA3_CounterReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.CounterReg ),
    archoff_TimerA3_ControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.ControlReg ),
    archoff_TimerA3_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerA.Channel3.StatusControlReg ),

#if !defined(DSP56838EVM)

    archoff_TimerB0 = (int) ( &((arch_sIO*)0)->TimerB.Channel0 ),        
    archoff_TimerB0_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerB.Channel0.CompareReg1 ),
    archoff_TimerB0_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerB.Channel0.CompareReg2 ),
    archoff_TimerB0_CaptureReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.CaptureReg ),
    archoff_TimerB0_LoadReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.LoadReg ),
    archoff_TimerB0_HoldReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.HoldReg ),
    archoff_TimerB0_CounterReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.CounterReg ),
    archoff_TimerB0_ControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.ControlReg ),
    archoff_TimerB0_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel0.StatusControlReg ),

    archoff_TimerB1 = (int) ( &((arch_sIO*)0)->TimerB.Channel1 ),
    archoff_TimerB1_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerB.Channel1.CompareReg1 ),
    archoff_TimerB1_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerB.Channel1.CompareReg2 ),
    archoff_TimerB1_CaptureReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.CaptureReg ),
    archoff_TimerB1_LoadReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.LoadReg ),
    archoff_TimerB1_HoldReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.HoldReg ),
    archoff_TimerB1_CounterReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.CounterReg ),
    archoff_TimerB1_ControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.ControlReg ),
    archoff_TimerB1_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel1.StatusControlReg ),

    archoff_TimerB2 = (int) ( &((arch_sIO*)0)->TimerB.Channel2 ),
    archoff_TimerB2_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerB.Channel2.CompareReg1 ),
    archoff_TimerB2_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerB.Channel2.CompareReg2 ),
    archoff_TimerB2_CaptureReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.CaptureReg ),
    archoff_TimerB2_LoadReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.LoadReg ),
    archoff_TimerB2_HoldReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.HoldReg ),
    archoff_TimerB2_CounterReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.CounterReg ),
    archoff_TimerB2_ControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.ControlReg ),
    archoff_TimerB2_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel2.StatusControlReg ),

    archoff_TimerB3 = (int) ( &((arch_sIO*)0)->TimerB.Channel3 ),
    archoff_TimerB3_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerB.Channel3.CompareReg1 ),
    archoff_TimerB3_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerB.Channel3.CompareReg2 ),
    archoff_TimerB3_CaptureReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.CaptureReg ),
    archoff_TimerB3_LoadReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.LoadReg ),
    archoff_TimerB3_HoldReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.HoldReg ),
    archoff_TimerB3_CounterReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.CounterReg ),
    archoff_TimerB3_ControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.ControlReg ),
    archoff_TimerB3_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerB.Channel3.StatusControlReg ),

#endif /* !defined(DSP56838EVM) */

	archoff_TimerC0 = (int) ( &((arch_sIO*)0)->TimerC.Channel0 ),
    archoff_TimerC0_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerC.Channel0.CompareReg1 ),
    archoff_TimerC0_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerC.Channel0.CompareReg2 ),
    archoff_TimerC0_CaptureReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.CaptureReg ),
    archoff_TimerC0_LoadReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.LoadReg ),
    archoff_TimerC0_HoldReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.HoldReg ),
    archoff_TimerC0_CounterReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.CounterReg ),
    archoff_TimerC0_ControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.ControlReg ),
    archoff_TimerC0_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel0.StatusControlReg ),

	archoff_TimerC1 = (int) ( &((arch_sIO*)0)->TimerC.Channel1 ),
    archoff_TimerC1_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerC.Channel1.CompareReg1 ),
    archoff_TimerC1_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerC.Channel1.CompareReg2 ),
    archoff_TimerC1_CaptureReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.CaptureReg ),
    archoff_TimerC1_LoadReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.LoadReg ),
    archoff_TimerC1_HoldReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.HoldReg ),
    archoff_TimerC1_CounterReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.CounterReg ),
    archoff_TimerC1_ControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.ControlReg ),
    archoff_TimerC1_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel1.StatusControlReg ),

	archoff_TimerC2 = (int) ( &((arch_sIO*)0)->TimerC.Channel2 ),
    archoff_TimerC2_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerC.Channel2.CompareReg1 ),
    archoff_TimerC2_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerC.Channel2.CompareReg2 ),
    archoff_TimerC2_CaptureReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.CaptureReg ),
    archoff_TimerC2_LoadReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.LoadReg ),
    archoff_TimerC2_HoldReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.HoldReg ),
    archoff_TimerC2_CounterReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.CounterReg ),
    archoff_TimerC2_ControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.ControlReg ),
    archoff_TimerC2_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel2.StatusControlReg ),

	archoff_TimerC3 = (int) ( &((arch_sIO*)0)->TimerC.Channel3 ),
    archoff_TimerC3_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerC.Channel3.CompareReg1 ),
    archoff_TimerC3_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerC.Channel3.CompareReg2 ),
    archoff_TimerC3_CaptureReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.CaptureReg ),
    archoff_TimerC3_LoadReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.LoadReg ),
    archoff_TimerC3_HoldReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.HoldReg ),
    archoff_TimerC3_CounterReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.CounterReg ),
    archoff_TimerC3_ControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.ControlReg ),
    archoff_TimerC3_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerC.Channel3.StatusControlReg ),

	archoff_TimerD0 = (int) ( &((arch_sIO*)0)->TimerD.Channel0 ),
    archoff_TimerD0_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerD.Channel0.CompareReg1 ),
    archoff_TimerD0_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerD.Channel0.CompareReg2 ),
    archoff_TimerD0_CaptureReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.CaptureReg ),
    archoff_TimerD0_LoadReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.LoadReg ),
    archoff_TimerD0_HoldReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.HoldReg ),
    archoff_TimerD0_CounterReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.CounterReg ),
    archoff_TimerD0_ControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.ControlReg ),
    archoff_TimerD0_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel0.StatusControlReg ),

	archoff_TimerD1 = (int) ( &((arch_sIO*)0)->TimerD.Channel1 ),
    archoff_TimerD1_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerD.Channel1.CompareReg1 ),
    archoff_TimerD1_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerD.Channel1.CompareReg2 ),
    archoff_TimerD1_CaptureReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.CaptureReg ),
    archoff_TimerD1_LoadReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.LoadReg ),
    archoff_TimerD1_HoldReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.HoldReg ),
    archoff_TimerD1_CounterReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.CounterReg ),
    archoff_TimerD1_ControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.ControlReg ),
    archoff_TimerD1_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel1.StatusControlReg ),

	archoff_TimerD2 = (int) ( &((arch_sIO*)0)->TimerD.Channel2 ),
    archoff_TimerD2_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerD.Channel2.CompareReg1 ),
    archoff_TimerD2_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerD.Channel2.CompareReg2 ),
    archoff_TimerD2_CaptureReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.CaptureReg ),
    archoff_TimerD2_LoadReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.LoadReg ),
    archoff_TimerD2_HoldReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.HoldReg ),
    archoff_TimerD2_CounterReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.CounterReg ),
    archoff_TimerD2_ControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.ControlReg ),
    archoff_TimerD2_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel2.StatusControlReg ),

	archoff_TimerD3 = (int) ( &((arch_sIO*)0)->TimerD.Channel3 ),
    archoff_TimerD3_CompareReg1 = (int) ( &((arch_sIO*)0)->TimerD.Channel3.CompareReg1 ),
    archoff_TimerD3_CompareReg2 = (int) ( &((arch_sIO*)0)->TimerD.Channel3.CompareReg2 ),
    archoff_TimerD3_CaptureReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.CaptureReg ),
    archoff_TimerD3_LoadReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.LoadReg ),
    archoff_TimerD3_HoldReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.HoldReg ),
    archoff_TimerD3_CounterReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.CounterReg ),
    archoff_TimerD3_ControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.ControlReg ),
    archoff_TimerD3_StatusControlReg = (int) ( &((arch_sIO*)0)->TimerD.Channel3.StatusControlReg ),
        /* PWM */
    archoff_PwmA = (int) ( &((arch_sIO*)0)->PwmA ),
    archoff_PwmA_ControlReg = (int) ( &((arch_sIO*)0)->PwmA.ControlReg ),
    archoff_PwmA_FaultControlReg = (int) ( &((arch_sIO*)0)->PwmA.FaultControlReg ),
    archoff_PwmA_FaultStatusReg = (int) ( &((arch_sIO*)0)->PwmA.FaultStatusReg ),
    archoff_PwmA_OutputControlReg = (int) ( &((arch_sIO*)0)->PwmA.OutputControlReg ),
    archoff_PwmA_CounterReg = (int) ( &((arch_sIO*)0)->PwmA.CounterReg ),
    archoff_PwmA_CounterModuloReg = (int) ( &((arch_sIO*)0)->PwmA.CounterModuloReg ),
    archoff_PwmA_ValueReg = (int) ( &((arch_sIO*)0)->PwmA.ValueReg[0] ), 
    archoff_PwmA_DeadtimeReg = (int) ( &((arch_sIO*)0)->PwmA.DeadtimeReg ),
    archoff_PwmA_DisableMapping1Reg = (int) ( &((arch_sIO*)0)->PwmA.DisableMapping1Reg ),
    archoff_PwmA_DisableMapping2Reg = (int) ( &((arch_sIO*)0)->PwmA.DisableMapping2Reg ),
    archoff_PwmA_ConfigReg = (int) ( &((arch_sIO*)0)->PwmA.ConfigReg ),
    archoff_PwmA_ChannelControlReg = (int) ( &((arch_sIO*)0)->PwmA.ChannelControlReg ),
    archoff_PwmA_PortReg = (int) ( &((arch_sIO*)0)->PwmA.PortReg ),

    archoff_PwmB = (int) ( &((arch_sIO*)0)->PwmB ),
    archoff_PwmB_ControlReg = (int) ( &((arch_sIO*)0)->PwmB.ControlReg ),
    archoff_PwmB_FaultControlReg = (int) ( &((arch_sIO*)0)->PwmB.FaultControlReg ),
    archoff_PwmB_FaultStatusReg = (int) ( &((arch_sIO*)0)->PwmB.FaultStatusReg ),
    archoff_PwmB_OutputControlReg = (int) ( &((arch_sIO*)0)->PwmB.OutputControlReg ),
    archoff_PwmB_CounterReg = (int) ( &((arch_sIO*)0)->PwmB.CounterReg ),
    archoff_PwmB_CounterModuloReg = (int) ( &((arch_sIO*)0)->PwmB.CounterModuloReg ),
    archoff_PwmB_ValueReg = (int) ( &((arch_sIO*)0)->PwmB.ValueReg[0] ), 
    archoff_PwmB_DeadtimeReg = (int) ( &((arch_sIO*)0)->PwmB.DeadtimeReg ),
    archoff_PwmB_DisableMapping1Reg = (int) ( &((arch_sIO*)0)->PwmB.DisableMapping1Reg ),
    archoff_PwmB_DisableMapping2Reg = (int) ( &((arch_sIO*)0)->PwmB.DisableMapping2Reg ),
    archoff_PwmB_ConfigReg = (int) ( &((arch_sIO*)0)->PwmB.ConfigReg ),
    archoff_PwmB_ChannelControlReg = (int) ( &((arch_sIO*)0)->PwmB.ChannelControlReg ),
    archoff_PwmB_PortReg = (int) ( &((arch_sIO*)0)->PwmB.PortReg ),
        /* Decoder */
    archoff_Decoder0 = (int) ( &((arch_sIO*)0)->Decoder0 ),
    archoff_Decoder0_ControlReg = (int) ( &((arch_sIO*)0)->Decoder0.ControlReg ),
    archoff_Decoder0_FilterIntervalReg = (int) ( &((arch_sIO*)0)->Decoder0.FilterIntervalReg ),
    archoff_Decoder0_WatchdogTimeoutReg = (int) ( &((arch_sIO*)0)->Decoder0.WatchdogTimeoutReg ),
    archoff_Decoder0_PositionDifferenceReg = (int) ( &((arch_sIO*)0)->Decoder0. PositionDifferenceReg ), 
    archoff_Decoder0_PositionDifferenceHoldReg = (int) ( &((arch_sIO*)0)->Decoder0.PositionDifferenceHoldReg ),
    archoff_Decoder0_RevolutionCounterReg = (int) ( &((arch_sIO*)0)->Decoder0. RevolutionCounterReg ), 
    archoff_Decoder0_RevolutionHoldReg = (int) ( &((arch_sIO*)0)->Decoder0.RevolutionHoldReg ),  
    archoff_Decoder0_UpperPositionCounterReg = (int) ( &((arch_sIO*)0)->Decoder0.UpperPositionCounterReg ),
    archoff_Decoder0_LowerPositionCounterReg = (int) ( &((arch_sIO*)0)->Decoder0.LowerPositionCounterReg ),
    archoff_Decoder0_UpperPositionHoldReg = (int) ( &((arch_sIO*)0)->Decoder0.UpperPositionHoldReg ),  
    archoff_Decoder0_LowerPositionHoldReg = (int) ( &((arch_sIO*)0)->Decoder0.LowerPositionHoldReg ),
    archoff_Decoder0_UpperInitializationReg = (int) ( &((arch_sIO*)0)->Decoder0.UpperInitializationReg ),  
    archoff_Decoder0_LowerInitializationReg = (int) ( &((arch_sIO*)0)->Decoder0.LowerInitializationReg ),
    archoff_Decoder0_InputMonitorReg = (int) ( &((arch_sIO*)0)->Decoder0.InputMonitorReg ),
    archoff_Decoder0_TestReg = (int) ( &((arch_sIO*)0)->Decoder0.TestReg ),
        /* IntCont */
    archoff_IntCtrl = (int) ( &((arch_sIO*)0)->IntCtrl ),        
    archoff_IntCtrl_IntPriorityReg = (int) ( &((arch_sIO*)0)->IntCtrl.IntPriorityReg[0] ),
    archoff_IntCtrl_VectorBaseAddrReg = (int) ( &((arch_sIO*)0)->IntCtrl.VectorBaseAddrReg ),
    archoff_IntCtrl_MatchReg0 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt0.MatchReg ),
    archoff_IntCtrl_VectorAddrLoReg0 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt0.VectorAddrLoReg ),
    archoff_IntCtrl_VectorAddrHiReg0 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt0.VectorAddrHiReg ),
    archoff_IntCtrl_MatchReg1 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt1.MatchReg ),
    archoff_IntCtrl_VectorAddrLoReg1 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt1.VectorAddrLoReg ),
    archoff_IntCtrl_VectorAddrHiReg1 = (int) ( &((arch_sIO*)0)->IntCtrl.FastInt1.VectorAddrHiReg ),
    archoff_IntCtrl_IRQPendingReg = (int) ( &((arch_sIO*)0)->IntCtrl.IRQPendingReg[0] ),
    archoff_IntCtrl_TestIRQSourceReg = (int) ( &((arch_sIO*)0)->IntCtrl.TestIRQSourceReg[0] ),
    archoff_IntCtrl_ControlReg = (int) ( &((arch_sIO*)0)->IntCtrl.ControlReg ),
    archoff_IntCtrl_TestControlReg = (int) ( &((arch_sIO*)0)->IntCtrl.TestControlReg ),

    archoff_AdcA = (int) ( &((arch_sIO*)0)->AdcA),
    archoff_AdcA_Control1Reg = (int) ( &((arch_sIO*)0)->AdcA.Control1Reg ),
    archoff_AdcA_Control2Reg = (int) ( &((arch_sIO*)0)->AdcA.Control2Reg ),
    archoff_AdcA_ZeroCrossControlReg = (int) ( &((arch_sIO*)0)->AdcA.ZeroCrossControlReg ),
    archoff_AdcA_ChannelList1Reg = (int) ( &((arch_sIO*)0)->AdcA.ChannelList1Reg ),
    archoff_AdcA_ChannelList2Reg = (int) ( &((arch_sIO*)0)->AdcA.ChannelList2Reg ),
    archoff_AdcA_DisableReg = (int) ( &((arch_sIO*)0)->AdcA.DisableReg ),
    archoff_AdcA_StatusReg = (int) ( &((arch_sIO*)0)->AdcA.StatusReg ),
    archoff_AdcA_LimitStatusReg = (int) ( &((arch_sIO*)0)->AdcA.LimitStatusReg ),
    archoff_AdcA_ZeroCrossStatusReg = (int) ( &((arch_sIO*)0)->AdcA.ZeroCrossStatusReg ),
    archoff_AdcA_ResultReg = (int) ( &((arch_sIO*)0)->AdcA.ResultReg[0] ),
    archoff_AdcA_LowLimitReg = (int) ( &((arch_sIO*)0)->AdcA.LowLimitReg[0] ),
    archoff_AdcA_HighLimitReg = (int) ( &((arch_sIO*)0)->AdcA.HighLimitReg[0] ),
    archoff_AdcA_OffsetReg = (int) ( &((arch_sIO*)0)->AdcA.OffsetReg[0] ),
    archoff_AdcA_PowerControl = (int) ( &((arch_sIO*)0)->AdcA.PowerControl ),

    archoff_AdcB = (int) ( &((arch_sIO*)0)->AdcB ),
    archoff_AdcB_Control1Reg = (int) ( &((arch_sIO*)0)->AdcB.Control1Reg ),
    archoff_AdcB_Control2Reg = (int) ( &((arch_sIO*)0)->AdcB.Control2Reg ),
    archoff_AdcB_ZeroCrossControlReg = (int) ( &((arch_sIO*)0)->AdcB.ZeroCrossControlReg ),
    archoff_AdcB_ChannelList1Reg = (int) ( &((arch_sIO*)0)->AdcB.ChannelList1Reg ),
    archoff_AdcB_ChannelList2Reg = (int) ( &((arch_sIO*)0)->AdcB.ChannelList2Reg ),
    archoff_AdcB_DisableReg = (int) ( &((arch_sIO*)0)->AdcB.DisableReg ),
    archoff_AdcB_StatusReg = (int) ( &((arch_sIO*)0)->AdcB.StatusReg ),
    archoff_AdcB_LimitStatusReg = (int) ( &((arch_sIO*)0)->AdcB.LimitStatusReg ),
    archoff_AdcB_ZeroCrossStatusReg = (int) ( &((arch_sIO*)0)->AdcB.ZeroCrossStatusReg ),
    archoff_AdcB_ResultReg = (int) ( &((arch_sIO*)0)->AdcB.ResultReg[0] ),
    archoff_AdcB_LowLimitReg = (int) ( &((arch_sIO*)0)->AdcB.LowLimitReg[0] ),
    archoff_AdcB_HighLimitReg = (int) ( &((arch_sIO*)0)->AdcB.HighLimitReg[0] ),
    archoff_AdcB_OffsetReg = (int) ( &((arch_sIO*)0)->AdcB.OffsetReg[0] ),
    archoff_AdcB_PowerControl = (int) ( &((arch_sIO*)0)->AdcB.PowerControl ),

    archoff_TempSensor_ControlReg = (int) ( &((arch_sIO*)0)->TempSensor.ControlReg ),

	/* SCI 0 */
	archoff_Sci0 = (int) ( &((arch_sIO*)0)->Sci0 ),
    archoff_Sci0_BaudRateReg = (int) ( &((arch_sIO*)0)->Sci0.BaudRateReg ),
    archoff_Sci0_ControlReg = (int) ( &((arch_sIO*)0)->Sci0.ControlReg ),
    archoff_Sci0_Reserved1 = (int) ( &((arch_sIO*)0)->Sci0.Reserved1 ),
    archoff_Sci0_StatusReg = (int) ( &((arch_sIO*)0)->Sci0.StatusReg ),
    archoff_Sci0_DataReg = (int) ( &((arch_sIO*)0)->Sci0.DataReg ),

	/* SCI 1 */
	archoff_Sci1 = (int) ( &((arch_sIO*)0)->Sci1 ),
    archoff_Sci1_BaudRateReg = (int) ( &((arch_sIO*)0)->Sci1.BaudRateReg ),
    archoff_Sci1_ControlReg = (int) ( &((arch_sIO*)0)->Sci1.ControlReg ),
    archoff_Sci1_Reserved1 = (int) ( &((arch_sIO*)0)->Sci1.Reserved1 ),
    archoff_Sci1_StatusReg = (int) ( &((arch_sIO*)0)->Sci1.StatusReg ),
    archoff_Sci1_DataReg = (int) ( &((arch_sIO*)0)->Sci1.DataReg ),

	/* SPI 0 */
    archoff_Spi0 = (int) ( &((arch_sIO*)0)->Spi0 ),
    archoff_Spi0_ControlReg = (int) ( &((arch_sIO*)0)->Spi0.ControlReg ),
    archoff_Spi0_DataSizeReg = (int) ( &((arch_sIO*)0)->Spi0.DataSizeReg ),
    archoff_Spi0_DataRxReg = (int) ( &((arch_sIO*)0)->Spi0.DataRxReg ),
    archoff_Spi0_DataTxReg = (int) ( &((arch_sIO*)0)->Spi0.DataTxReg ),
    
	/* SPI 1 */
    archoff_Spi1 = (int) ( &((arch_sIO*)0)->Spi1 ),
    archoff_Spi1_ControlReg = (int) ( &((arch_sIO*)0)->Spi1.ControlReg ),
    archoff_Spi1_DataSizeReg = (int) ( &((arch_sIO*)0)->Spi1.DataSizeReg ),
    archoff_Spi1_DataRxReg = (int) ( &((arch_sIO*)0)->Spi1.DataRxReg ),
    archoff_Spi1_DataTxReg = (int) ( &((arch_sIO*)0)->Spi1.DataTxReg ),

    archoff_Cop = (int) ( &((arch_sIO*)0)->Cop),
    archoff_Cop_ControlReg = (int) ( &((arch_sIO*)0)->Cop.ControlReg ),
    archoff_Cop_TimeoutReg = (int) ( &((arch_sIO*)0)->Cop.TimeoutReg ),
    archoff_Cop_ServiceReg = (int) ( &((arch_sIO*)0)->Cop.ServiceReg ),
    
     /* PLL */
    archoff_Pll = (int) ( &((arch_sIO*)0)->Pll),
    archoff_Pll_ControlReg = (int) ( &((arch_sIO*)0)->Pll.ControlReg ),
    archoff_Pll_DivideReg = (int) ( &((arch_sIO*)0)->Pll.DivideReg ),
    archoff_Pll_StatusReg = (int) ( &((arch_sIO*)0)->Pll.StatusReg ),
    archoff_Pll_TestReg = (int) ( &((arch_sIO*)0)->Pll.TestReg ),
    archoff_Pll_SelectReg = (int) ( &((arch_sIO*)0)->Pll.SelectReg ),
    archoff_Pll_OscControlReg = (int) ( &((arch_sIO*)0)->Pll.OscControlReg ),

    archoff_PortA = (int) ( &((arch_sIO*)0)->PortA ),
    archoff_PortA_PullUpReg = (int) ( &((arch_sIO*)0)->PortA.PullUpReg ),
    archoff_PortA_DataReg = (int) ( &((arch_sIO*)0)->PortA.DataReg ),
    archoff_PortA_DataDirectionReg = (int) ( &((arch_sIO*)0)->PortA.DataDirectionReg ),
    archoff_PortA_PeripheralReg = (int) ( &((arch_sIO*)0)->PortA.PeripheralReg ),
    archoff_PortA_IntAssertReg = (int) ( &((arch_sIO*)0)->PortA.IntAssertReg ),
    archoff_PortA_IntEnableReg = (int) ( &((arch_sIO*)0)->PortA.IntEnableReg ),
    archoff_PortA_IntPolarityReg = (int) ( &((arch_sIO*)0)->PortA.IntPolarityReg ),
    archoff_PortA_IntPendingReg = (int) ( &((arch_sIO*)0)->PortA.IntPendingReg ),
    archoff_PortA_IntEdgeSensReg = (int) ( &((arch_sIO*)0)->PortA.IntEdgeSensReg ),
    archoff_PortA_RawDataInputReg = (int) ( &((arch_sIO*)0)->PortA.RawDataInputReg ),

    archoff_PortB = (int) ( &((arch_sIO*)0)->PortB),
    archoff_PortB_PullUpReg = (int) ( &((arch_sIO*)0)->PortB.PullUpReg ),
    archoff_PortB_DataReg = (int) ( &((arch_sIO*)0)->PortB.DataReg ),
    archoff_PortB_DataDirectionReg = (int) ( &((arch_sIO*)0)->PortB.DataDirectionReg ),
    archoff_PortB_PeripheralReg = (int) ( &((arch_sIO*)0)->PortB.PeripheralReg ),
    archoff_PortB_IntAssertReg = (int) ( &((arch_sIO*)0)->PortB.IntAssertReg ),
    archoff_PortB_IntEnableReg = (int) ( &((arch_sIO*)0)->PortB.IntEnableReg ),
    archoff_PortB_IntPolarityReg = (int) ( &((arch_sIO*)0)->PortB.IntPolarityReg ),
    archoff_PortB_IntPendingReg = (int) ( &((arch_sIO*)0)->PortB.IntPendingReg ),
    archoff_PortB_IntEdgeSensReg = (int) ( &((arch_sIO*)0)->PortB.IntEdgeSensReg ),
    archoff_PortB_RawDataInputReg = (int) ( &((arch_sIO*)0)->PortB.RawDataInputReg ),

    archoff_PortC = (int) ( &((arch_sIO*)0)->PortC ),
    archoff_PortC_PullUpReg = (int) ( &((arch_sIO*)0)->PortC.PullUpReg ),
    archoff_PortC_DataReg = (int) ( &((arch_sIO*)0)->PortC.DataReg ),
    archoff_PortC_DataDirectionReg = (int) ( &((arch_sIO*)0)->PortC.DataDirectionReg ),
    archoff_PortC_PeripheralReg = (int) ( &((arch_sIO*)0)->PortC.PeripheralReg ),
    archoff_PortC_IntAssertReg = (int) ( &((arch_sIO*)0)->PortC.IntAssertReg ),
    archoff_PortC_IntEnableReg = (int) ( &((arch_sIO*)0)->PortC.IntEnableReg ),
    archoff_PortC_IntPolarityReg = (int) ( &((arch_sIO*)0)->PortC.IntPolarityReg ),
    archoff_PortC_IntPendingReg = (int) ( &((arch_sIO*)0)->PortC.IntPendingReg ),
    archoff_PortC_IntEdgeSensReg = (int) ( &((arch_sIO*)0)->PortC.IntEdgeSensReg ),
    archoff_PortC_RawDataInputReg = (int) ( &((arch_sIO*)0)->PortC.RawDataInputReg ),

    archoff_PortD = (int) ( &((arch_sIO*)0)->PortD),
    archoff_PortD_PullUpReg = (int) ( &((arch_sIO*)0)->PortD.PullUpReg ),
    archoff_PortD_DataReg = (int) ( &((arch_sIO*)0)->PortD.DataReg ),
    archoff_PortD_DataDirectionReg = (int) ( &((arch_sIO*)0)->PortD.DataDirectionReg ),
    archoff_PortD_PeripheralReg = (int) ( &((arch_sIO*)0)->PortD.PeripheralReg ),
    archoff_PortD_IntAssertReg = (int) ( &((arch_sIO*)0)->PortD.IntAssertReg ),
    archoff_PortD_IntEnableReg = (int) ( &((arch_sIO*)0)->PortD.IntEnableReg ),
    archoff_PortD_IntPolarityReg = (int) ( &((arch_sIO*)0)->PortD.IntPolarityReg ),
    archoff_PortD_IntPendingReg = (int) ( &((arch_sIO*)0)->PortD.IntPendingReg ),
    archoff_PortD_IntEdgeSensReg = (int) ( &((arch_sIO*)0)->PortD.IntEdgeSensReg ),
    archoff_PortD_RawDataInputReg = (int) ( &((arch_sIO*)0)->PortD.RawDataInputReg ),

    archoff_PortE = (int) ( &((arch_sIO*)0)->PortE),
    archoff_PortE_PullUpReg = (int) ( &((arch_sIO*)0)->PortE.PullUpReg ),
    archoff_PortE_DataReg = (int) ( &((arch_sIO*)0)->PortE.DataReg ),
    archoff_PortE_DataDirectionReg = (int) ( &((arch_sIO*)0)->PortE.DataDirectionReg ),
    archoff_PortE_PeripheralReg = (int) ( &((arch_sIO*)0)->PortE.PeripheralReg ),
    archoff_PortE_IntAssertReg = (int) ( &((arch_sIO*)0)->PortE.IntAssertReg ),
    archoff_PortE_IntEnableReg = (int) ( &((arch_sIO*)0)->PortE.IntEnableReg ),
    archoff_PortE_IntPolarityReg = (int) ( &((arch_sIO*)0)->PortE.IntPolarityReg ),
    archoff_PortE_IntPendingReg = (int) ( &((arch_sIO*)0)->PortE.IntPendingReg ),
    archoff_PortE_IntEdgeSensReg = (int) ( &((arch_sIO*)0)->PortE.IntEdgeSensReg ),
    archoff_PortE_RawDataInputReg = (int) ( &((arch_sIO*)0)->PortE.RawDataInputReg ),

    archoff_Sim = (int) ( &((arch_sIO*)0)->Sim),
    archoff_Sim_ControlReg = (int) ( &((arch_sIO*)0)->Sim.ControlReg ),
    archoff_Sim_StatusReg = (int) ( &((arch_sIO*)0)->Sim.StatusReg ),
    archoff_Sim_SoftwareControlReg = (int) ( &((arch_sIO*)0)->Sim.SoftwareControlReg[0] ),
    archoff_Sim_MostSignificantHalfJTAGIDReg = (int) ( &((arch_sIO*)0)->Sim.MostSignificantHalfJTAGIDReg ),
    archoff_Sim_LeastSignificantHalfJTAGIDReg = (int) ( &((arch_sIO*)0)->Sim.LeastSignificantHalfJTAGIDReg ),
    archoff_Sim_PullupDisableReg = (int) ( &((arch_sIO*)0)->Sim.PullupDisableReg ),
    archoff_Sim_TestReg = (int) ( &((arch_sIO*)0)->Sim.TestReg ),
    archoff_Sim_ClockSelectReg = (int) ( &((arch_sIO*)0)->Sim.ClockSelectReg ),

    archoff_Lvi = (int) ( &((arch_sIO*)0)->Lvi),
    archoff_Lvi_ControlReg = (int) ( &((arch_sIO*)0)->Lvi.ControlReg ),
    archoff_Lvi_StatusReg = (int) ( &((arch_sIO*)0)->Lvi.StatusReg ),
    archoff_Lvi_TestReg = (int) ( &((arch_sIO*)0)->Lvi.TestReg ),

    archoff_Flash = (int) ( &((arch_sIO*)0)->Flash),
    archoff_Flash_ClockDividerReg = (int) ( &((arch_sIO*)0)->Flash.ClockDividerReg ),
    archoff_Flash_ModuleControlReg = (int) ( &((arch_sIO*)0)->Flash.ModuleControlReg ),
    archoff_Flash_Reserved1 = (int) ( &((arch_sIO*)0)->Flash.Reserved1 ),
    archoff_Flash_SecurityHiReg = (int) ( &((arch_sIO*)0)->Flash.SecurityHiReg ),
    archoff_Flash_SecurityLoReg = (int) ( &((arch_sIO*)0)->Flash.SecurityLoReg ),
    archoff_Flash_ProtectionReg = (int) ( &((arch_sIO*)0)->Flash.ProtectionReg ),
    archoff_Flash_ProtectionBootReg = (int) ( &((arch_sIO*)0)->Flash.ProtectionBootReg ),
    archoff_Flash_UserStatusReg = (int) ( &((arch_sIO*)0)->Flash.UserStatusReg ),
    archoff_Flash_CommandReg = (int) ( &((arch_sIO*)0)->Flash.CommandReg ),

#if !defined(DSP56838EVM)
    archoff_FlexCAN = (int) ( &((arch_sIO*)0)->CAN ),
    archoff_FlexCAN_ConfigReg = (int)&((arch_sIO*)0)->CAN.ConfigReg,
    archoff_FlexCAN_TestConfigReg = (int)&((arch_sIO*)0)->CAN.TestConfigReg,
    archoff_FlexCAN_Control0Reg = (int)&((arch_sIO*)0)->CAN.Control0Reg,
    archoff_FlexCAN_Control1Reg = (int)&((arch_sIO*)0)->CAN.Control1Reg,
    archoff_FlexCAN_TimerReg = (int)&((arch_sIO*)0)->CAN.TimerReg,
    archoff_FlexCAN_MaxMBReg = (int)&((arch_sIO*)0)->CAN.MaxMBReg,
    archoff_FlexCAN_IntMask2Reg = (int)&((arch_sIO*)0)->CAN.IntMask2Reg,
    archoff_FlexCAN_RxGlobalMaskHiReg = (int)&((arch_sIO*)0)->CAN.RxGlobalMaskHiReg,
    archoff_FlexCAN_RxGlobalMaskLoReg = (int)&((arch_sIO*)0)->CAN.RxGlobalMaskLoReg,
    archoff_FlexCAN_Rx14MaskHiReg = (int)&((arch_sIO*)0)->CAN.Rx14MaskHiReg,
    archoff_FlexCAN_Rx14MaskLoReg = (int)&((arch_sIO*)0)->CAN.Rx14MaskLoReg,
    archoff_FlexCAN_Rx15MaskHiReg = (int)&((arch_sIO*)0)->CAN.Rx15MaskHiReg,
    archoff_FlexCAN_Rx15MaskLoReg = (int)&((arch_sIO*)0)->CAN.Rx15MaskLoReg,
    archoff_FlexCAN_StatusReg = (int)&((arch_sIO*)0)->CAN.StatusReg,
    archoff_FlexCAN_IntMask1Reg = (int)&((arch_sIO*)0)->CAN.IntMask1Reg,
    archoff_FlexCAN_IntFlags1Reg = (int)&((arch_sIO*)0)->CAN.IntFlags1Reg,
    archoff_FlexCAN_ErrorCounterReg = (int)&((arch_sIO*)0)->CAN.ErrorCounterReg,
    archoff_FlexCAN_Test1Reg_0 = (int)&((arch_sIO*)0)->CAN.Test1Reg[0],    
    archoff_FlexCAN_IntFlags2Reg = (int)&((arch_sIO*)0)->CAN.IntFlags2Reg,
    archoff_FlexCAN_Test2Reg_0 = (int)&((arch_sIO*)0)->CAN.Test2Reg[0],
    archoff_FlexCAN_Buffer_0 = (int)&((arch_sIO*)0)->CAN.Buffer[0],
#endif /* !defined(DSP56838EVM) */

    archoff_end
};

/******************** Separate device offset ******************************************/

enum arch_SPI_offsets{
	arch_sSPI_offset_ControlReg = (int)&((arch_sSPI*)0)->ControlReg,
	arch_sSPI_offset_DataSizeReg = (int)&((arch_sSPI*)0)->DataSizeReg,
	arch_sSPI_offset_DataRxReg = (int)&((arch_sSPI*)0)->DataRxReg,
	arch_sSPI_offset_DataTxReg = (int)&((arch_sSPI*)0)->DataTxReg
};

enum arch_SCI_offsets{
    arch_sSCI_offset_ControlReg	= (int)&((arch_sSCI*)0)->ControlReg,
    arch_sSCI_offset_StatusReg	= (int)&((arch_sSCI*)0)->StatusReg,
    arch_sSCI_offset_DataReg	= (int)&((arch_sSCI*)0)->DataReg
};

enum arch_PWM_offsets{
    arch_sPWM_offset_ControlReg 		= (int)  &((arch_sPWM*)0) -> ControlReg 		,
    arch_sPWM_offset_FaultControlReg 	= (int)  &((arch_sPWM*)0) -> FaultControlReg 	,
    arch_sPWM_offset_FaultStatusReg 	= (int)  &((arch_sPWM*)0) -> FaultStatusReg 	,
    arch_sPWM_offset_OutputControlReg 	= (int)  &((arch_sPWM*)0) -> OutputControlReg 	,
    arch_sPWM_offset_CounterReg 		= (int)  &((arch_sPWM*)0) -> CounterReg 		,
    arch_sPWM_offset_CounterModuloReg 	= (int)  &((arch_sPWM*)0) -> CounterModuloReg 	,
    arch_sPWM_offset_ValueReg 			= (int)  &((arch_sPWM*)0) -> ValueReg[0] 		, 
    arch_sPWM_offset_DeadtimeReg 		= (int)  &((arch_sPWM*)0) -> DeadtimeReg 		,
    arch_sPWM_offset_DisableMapping1Reg = (int)  &((arch_sPWM*)0) -> DisableMapping1Reg	,
    arch_sPWM_offset_DisableMapping2Reg = (int)  &((arch_sPWM*)0) -> DisableMapping2Reg	,
    arch_sPWM_offset_ConfigReg 			= (int)  &((arch_sPWM*)0) -> ConfigReg 			,
    arch_sPWM_offset_ChannelControlReg 	= (int)  &((arch_sPWM*)0) -> ChannelControlReg 	,
    arch_sPWM_offset_PortReg 			= (int)  &((arch_sPWM*)0) -> PortReg 			
};
enum arch_ADC_offsets{
    arch_sADC_offset_Control1Reg		= (int)&((arch_sADC*)0)->Control1Reg,
    arch_sADC_offset_Control2Reg		= (int)&((arch_sADC*)0)->Control2Reg,
    arch_sADC_offset_ZeroCrossControlReg= (int)&((arch_sADC*)0)->ZeroCrossControlReg,
    arch_sADC_offset_ChannelList1Reg	= (int)&((arch_sADC*)0)->ChannelList1Reg,
    arch_sADC_offset_ChannelList2Reg	= (int)&((arch_sADC*)0)->ChannelList2Reg,
    arch_sADC_offset_DisableReg			= (int)&((arch_sADC*)0)->DisableReg,
    arch_sADC_offset_StatusReg			= (int)&((arch_sADC*)0)->StatusReg,
    arch_sADC_offset_LimitStatusReg			= (int)&((arch_sADC*)0)->LimitStatusReg,
    arch_sADC_offset_ZeroCrossStatusReg	= (int)&((arch_sADC*)0)->ZeroCrossStatusReg,
    arch_sADC_offset_Result0Reg			= (int)&((arch_sADC*)0)->ResultReg[0],
    arch_sADC_offset_Result1Reg			= (int)&((arch_sADC*)0)->ResultReg[1],
    arch_sADC_offset_Result2Reg			= (int)&((arch_sADC*)0)->ResultReg[2],
    arch_sADC_offset_Result3Reg			= (int)&((arch_sADC*)0)->ResultReg[3],
    arch_sADC_offset_Result4Reg			= (int)&((arch_sADC*)0)->ResultReg[4],
    arch_sADC_offset_Result5Reg			= (int)&((arch_sADC*)0)->ResultReg[5],
    arch_sADC_offset_Result6Reg			= (int)&((arch_sADC*)0)->ResultReg[6],
    arch_sADC_offset_Result7Reg			= (int)&((arch_sADC*)0)->ResultReg[7],
    arch_sADC_offset_LowLimit0Reg		= (int)&((arch_sADC*)0)->LowLimitReg[0],
    arch_sADC_offset_LowLimit1Reg		= (int)&((arch_sADC*)0)->LowLimitReg[1],
    arch_sADC_offset_LowLimit2Reg		= (int)&((arch_sADC*)0)->LowLimitReg[2],
    arch_sADC_offset_LowLimit3Reg		= (int)&((arch_sADC*)0)->LowLimitReg[3],
    arch_sADC_offset_LowLimit4Reg		= (int)&((arch_sADC*)0)->LowLimitReg[4],
    arch_sADC_offset_LowLimit5Reg		= (int)&((arch_sADC*)0)->LowLimitReg[5],
    arch_sADC_offset_LowLimit6Reg		= (int)&((arch_sADC*)0)->LowLimitReg[6],
    arch_sADC_offset_LowLimit7Reg		= (int)&((arch_sADC*)0)->LowLimitReg[7],
    arch_sADC_offset_HighLimit0Reg		= (int)&((arch_sADC*)0)->HighLimitReg[0],
    arch_sADC_offset_HighLimit1Reg		= (int)&((arch_sADC*)0)->HighLimitReg[1],
    arch_sADC_offset_HighLimit2Reg		= (int)&((arch_sADC*)0)->HighLimitReg[2],
    arch_sADC_offset_HighLimit3Reg		= (int)&((arch_sADC*)0)->HighLimitReg[3],
    arch_sADC_offset_HighLimit4Reg		= (int)&((arch_sADC*)0)->HighLimitReg[4],
    arch_sADC_offset_HighLimit5Reg		= (int)&((arch_sADC*)0)->HighLimitReg[5],
    arch_sADC_offset_HighLimit6Reg		= (int)&((arch_sADC*)0)->HighLimitReg[6],
    arch_sADC_offset_HighLimit7Reg		= (int)&((arch_sADC*)0)->HighLimitReg[7],
    arch_sADC_offset_Offset0Reg			= (int)&((arch_sADC*)0)->OffsetReg[0],
    arch_sADC_offset_Offset1Reg			= (int)&((arch_sADC*)0)->OffsetReg[1],
    arch_sADC_offset_Offset2Reg			= (int)&((arch_sADC*)0)->OffsetReg[2],
    arch_sADC_offset_Offset3Reg			= (int)&((arch_sADC*)0)->OffsetReg[3],
    arch_sADC_offset_Offset4Reg			= (int)&((arch_sADC*)0)->OffsetReg[4],
    arch_sADC_offset_Offset5Reg			= (int)&((arch_sADC*)0)->OffsetReg[5],
    arch_sADC_offset_Offset6Reg			= (int)&((arch_sADC*)0)->OffsetReg[6],
    arch_sADC_offset_Offset7Reg			= (int)&((arch_sADC*)0)->OffsetReg[7],
    arch_sADC_offset_PowerControl		= (int)&((arch_sADC*)0)->PowerControl
};

enum arch_FlexCAN_offsets{

    devoff_FlexCANBuffer_CtlStatusReg = (int)&((arch_sFlexCANBuffer*)0)->CtlStatusReg,
    devoff_FlexCANBuffer_IdRegHi = (int)&((arch_sFlexCANBuffer*)0)->IdRegHi,
    devoff_FlexCANBuffer_IdRegLo = (int)&((arch_sFlexCANBuffer*)0)->IdRegLo,
    devoff_FlexCANBuffer_DataSegReg_0 = (int)&((arch_sFlexCANBuffer*)0)->DataSegReg[0],

    devoff_FlexCAN_ConfigReg = (int)&((arch_sFlexCAN*)0)->ConfigReg,
    devoff_FlexCAN_TestConfigReg = (int)&((arch_sFlexCAN*)0)->TestConfigReg,
    devoff_FlexCAN_Control0Reg = (int)&((arch_sFlexCAN*)0)->Control0Reg,
    devoff_FlexCAN_Control1Reg = (int)&((arch_sFlexCAN*)0)->Control1Reg,
    devoff_FlexCAN_TimerReg = (int)&((arch_sFlexCAN*)0)->TimerReg,
    devoff_FlexCAN_MaxMBReg = (int)&((arch_sFlexCAN*)0)->MaxMBReg,
    devoff_FlexCAN_IntMask2Reg = (int)&((arch_sFlexCAN*)0)->IntMask2Reg,
    devoff_FlexCAN_RxGlobalMaskHiReg = (int)&((arch_sFlexCAN*)0)->RxGlobalMaskHiReg,
    devoff_FlexCAN_RxGlobalMaskLoReg = (int)&((arch_sFlexCAN*)0)->RxGlobalMaskLoReg,
    devoff_FlexCAN_Rx14MaskHiReg = (int)&((arch_sFlexCAN*)0)->Rx14MaskHiReg,
    devoff_FlexCAN_Rx14MaskLoReg = (int)&((arch_sFlexCAN*)0)->Rx14MaskLoReg,
    devoff_FlexCAN_Rx15MaskHiReg = (int)&((arch_sFlexCAN*)0)->Rx15MaskHiReg,
    devoff_FlexCAN_Rx15MaskLoReg = (int)&((arch_sFlexCAN*)0)->Rx15MaskLoReg,
    devoff_FlexCAN_StatusReg = (int)&((arch_sFlexCAN*)0)->StatusReg,
    devoff_FlexCAN_IntMask1Reg = (int)&((arch_sFlexCAN*)0)->IntMask1Reg,
    devoff_FlexCAN_IntFlags1Reg = (int)&((arch_sFlexCAN*)0)->IntFlags1Reg,
    devoff_FlexCAN_ErrorCounterReg = (int)&((arch_sFlexCAN*)0)->ErrorCounterReg,
    devoff_FlexCAN_Test1Reg_0 = (int)&((arch_sFlexCAN*)0)->Test1Reg[0],    /* MCntrl SCntrl*/
    devoff_FlexCAN_IntFlags2Reg = (int)&((arch_sFlexCAN*)0)->IntFlags2Reg,
    devoff_FlexCAN_Test2Reg_0 = (int)&((arch_sFlexCAN*)0)->Test2Reg[0],
    devoff_FlexCAN_Buffer_0 = (int)&((arch_sFlexCAN*)0)->Buffer[0]
};



#endif /* ARCH_OFF_H */