#ifndef __APPCONFIG_H
#define __APPCONFIG_H

/* Refer to config/config.h for complete list of all components and
	component default initialization */

/*****************************************************************************
*
* Include needed SDK components
*
*****************************************************************************/
#define INCLUDE_BSP         
#define INCLUDE_CAN
#define INCLUDE_FLEXCAN
#define INCLUDE_FLASH	      

/*****************************************************************************
*
* Overwrite default component initializations from config/config.h
* using #defines here
*
*****************************************************************************/
#undef USE_HYPERTERMINAL

#define CAN_CLOCK_SOURCE     CAN_IP_BUS_CLOCK
#define CAN_SPEED            500000     
#define CAN20B

#define SCI0_RXBUF_SIZE      512
#define SCI0_TXBUF_SIZE      32

#define PLL_MUL              24 // for flash programming 

// PLL is reprogrammed to its initial state after application downloading.
#define PLL_MUL_INI             30
#define PLL_CONTROL_REG_INI 	(PLL_LOCK_DETECTOR | PLL_ZCLOCK_POSTSCALER)
#define PLL_DIVIDE_BY_REG_INI	((PLL_MUL_INI - 1) |  PLL_CLOCK_IN_DIVIDE_BY_1 | PLL_CLOCK_OUT_DIVIDE_BY_1)

#endif