/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/config/const.c $ 
* $Author: saa $ 
* $Revision: /main/2 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:       SDK configurable constant in Data Flash 
*
* Notes:  
*
******************************************************************************/
#include "port.h"
#include "arch.h"
#include "bsp.h"
#include "io.h"
#include "pll.h"
#include "gpiodrv.h"
#include "scidrv.h"
#include "flexcan.h"
#include "flashdrv.h"
#include "arch_off.h"

#define ArchInstallCallBackISR(device,num, type, CallBack, prio ) extern void SDK_stb(void)

// include user and default configuration 
#include "config.h"

void Sci0Tx_DispatchCallback(void);
void Sci0Tx_DispatchCallback(void){};

void Sci1Tx_DispatchCallback(void);
void Sci1Tx_DispatchCallback(void){};

void Sci0Rx_DispatchCallback(void);
void Sci0Rx_DispatchCallback(void){};

void Sci1Rx_DispatchCallback(void);
void Sci1Rx_DispatchCallback(void){};

/*****************************************************************************/
#ifdef INCLUDE_FLEXCAN

#ifdef INCLUDE_IO
    const io_sFLEXCANInterface canInterfaceVT = {      
        flexcanRead, 
        flexcanWrite,         
        flexcanClose, 
        { ioctlCAN_GET_STATUS, ioctlCANID_GET_STATUS,
          ioctlCAN_RESET, ioctlCAN_SET_SLEEP, ioctlCAN_SET_WAKEUP,
        }, 
    };
#else 
    const io_sFLEXCANInterface canInterfaceVT = {      
        no_read, 
        no_write,         
        no_close, 
        { no_ioctl, no_ioctl,
          no_ioctl, no_ioctl, no_ioctl
        }, 
    };
#endif 

     const can_pRawCallBack CANRcvPrepare =   //  RAW CallBack pointer 
    #if defined(CAN_RAW_CALLBACK)
		CAN_RAW_CALLBACK;
    #else
        NULL;
    #endif  
   
    const can_sInitialState canInitialState = {   	
        3,
    #if defined(CAN_RAW_CALLBACK)
		CAN_RAW_CALLBACK,
    #else
        NULL,
    #endif  

        /* FCMCR = */   0x5000 
                        | ( CAN_WAKE_UP_MODE << 6 ),
        /* FCCTL0 = */  0 
                        | ( CAN_SAMPLING << 7)
                        | ( CAN_LOOP_BACK << 6)
                        | ( CAN_PROP_SEGMENT - 1) ,
        /* FCCTL1 = */  0
                        | (( CAN_PRESCALER - 1 ) << 8)
                        | (( CAN_SYNCH_JUMP_WIDTH - 1) << 6)
                        | (( CAN_PHASE_SEGMENT1 - 1 ) << 3 ) 
                        | (  CAN_PHASE_SEGMENT2 - 1 )
	};

    const unsigned int FlexCANFlags = 0
#if defined( CAN20B )
                        | O_CAN_2B
#endif
#if  CAN_LOOP_BACK == 1
                        | O_LOOP_BACK
#endif 
        ;  
#endif 

/*****************************************************************************/
#if defined( INCLUDE_SCI )
		
	#if defined(INCLUDE_IO)
	
		const struct io_sSCIInterface scidrvIOBlockInterfaceVT = 
		{
			sciBlockRead, sciBlockWrite, sciClose, SCI_IOCTLs
		};

		const struct io_sSCIInterface scidrvIONonBlockInterfaceVT = 
		{
			sciNonBlockRead, sciNonBlockWrite,sciClose,	SCI_IOCTLs
		};
	
	#else 
	
		const io_sInterface scidrvIOBlockInterfaceVT = 
		{
			noSciBlockRead, noSciBlockWrite, noSciClose, noSciIoctl
		};

		const io_sInterface scidrvIONonBlockInterfaceVT = 
		{
			noSciNonBlockRead, noSciNonBlockWrite, noSciClose, noSciIoctl
		};
	#endif 

  #if defined(BSP_DEVICE_NAME_SCI_0)
  
	struct sSciDevice Sci0DeviceContext = 
   	   {
   	      (io_sInterface *)&scidrvIONonBlockInterfaceVT,
          &ArchIO.Sci0,        	/* Base */
	   	  SCI_SCIDR_8BIT_MASK, 	/* Mask */
	   	  /* receive */
      	  {
           	0, 	/* begin */
           	0, 	/* marker*/
           	SCI0_RXBUF_MASK,	/* mask */
           	SCI0_RXBUF_OFFSET	/* buffer address */
      	  },
      	  /* send */
      	  {
           	0, 	/* begin */
           	0, 	/* marker*/
           	SCI0_TXBUF_MASK,	/* mask */
           	SCI0_TXBUF_OFFSET	/* buffer address */
      	  }
	   };
  #endif
  
  #if defined(BSP_DEVICE_NAME_SCI_1)   
  
	struct sSciDevice Sci1DeviceContext = 
   	   {
   	   (io_sInterface *)&scidrvIONonBlockInterfaceVT,
          &ArchIO.Sci1,       		 		/* Base */
      	  SCI_SCIDR_8BIT_MASK,              /* Mask */
      	  /*receive*/
      	  {
             0, 	/* begin */
             0, 	/* marker*/
             SCI1_RXBUF_MASK,	/* mask */
             SCI1_RXBUF_OFFSET	/* buffer address */
      	  },
      	  /*send*/
      	  {
             0, 				/* begin */
             0, 				/* marker*/
             SCI1_TXBUF_MASK,	/* mask */
             SCI1_TXBUF_OFFSET	/* buffer address */
      	  }
	   };
  #endif 
#endif 

/*****************************************************************************/
#if defined( INCLUDE_GPIO )

        const io_sGPIOInterface gpiodrvIOInterfaceVT = {
        gpioRead,
        gpioWrite,
        gpioClose,
#if defined( GPIO_INLINE )
        NULL,
#else                
        {
        gpioIoctlGPIO_SET,
        gpioIoctlGPIO_CLEAR,
        gpioIoctlGPIO_TOGGLE,
        gpioIoctlGPIO_DISABLE_PULLUP,
        gpioIoctlGPIO_ENABLE_PULLUP,
        gpioIoctlGPIO_SETAS_INPUT,
        gpioIoctlGPIO_SETAS_OUTPUT,
        gpioIoctlGPIO_SETAS_GPIO,
        gpioIoctlGPIO_SETAS_PERIPHERAL,
        gpioIoctlGPIO_INTERRUPT_ASSERT_DISABLE,
        gpioIoctlGPIO_INTERRUPT_ASSERT_ENABLE,
        gpioIoctlGPIO_INTERRUPT_DISABLE,
        gpioIoctlGPIO_INTERRUPT_ENABLE,
        gpioIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_HIGH,
        gpioIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_LOW,
        gpioIoctlGPIO_CLEAR_INTERRUPT_PEND_REGISTER,
        gpioIoctlGPIO_READ
        }
#endif
    };


        const io_sGPIOInterface gpiopinInterfaceVT = {
        gpiopinRead,
        gpiopinWrite,
        gpiopinClose,
        {
        gpiopinIoctlGPIO_SET,
        gpiopinIoctlGPIO_CLEAR,
        gpiopinIoctlGPIO_TOGGLE,
        gpiopinIoctlGPIO_DISABLE_PULLUP,
        gpiopinIoctlGPIO_ENABLE_PULLUP,
        gpiopinIoctlGPIO_SETAS_INPUT,
        gpiopinIoctlGPIO_SETAS_OUTPUT,
        gpiopinIoctlGPIO_SETAS_GPIO,
        gpiopinIoctlGPIO_SETAS_PERIPHERAL,
        gpiopinIoctlGPIO_INTERRUPT_ASSERT_DISABLE,
        gpiopinIoctlGPIO_INTERRUPT_ASSERT_ENABLE,
        gpiopinIoctlGPIO_INTERRUPT_DISABLE,
        gpiopinIoctlGPIO_INTERRUPT_ENABLE,
        gpiopinIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_HIGH,
        gpiopinIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_LOW,
        gpiopinIoctlGPIO_CLEAR_INTERRUPT_PEND_REGISTER,
        gpiopinIoctlGPIO_READ
        }
    };
    
    sGpioDevice pinPortAMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_A)
        	{
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_A) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

    sGpioDevice pinPortBMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_B)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_B) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

  
    sGpioDevice pinPortCMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_C)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_C) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            }
        };

    sGpioDevice pinPortDMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_D)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_D) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

    sGpioDevice pinPortEMap[] = 
        {
   #if defined(BSP_DEVICE_NAME_GPIO_E)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_E) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40	                           /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80	        			       /* Mask */
            }
        };


#endif 

/*****************************************************************************/
#if defined( INCLUDE_FLASH )

#ifdef INCLUDE_IO 
    const io_sFlashInterface flash_io_interface = { 
        flashRead, flashWrite, flashClose, 
        {   
            ioctlFLASH_RESET, ioctlFLASH_MODE_VERIFY, ioctlFLASH_CMD_SEEK 
        }
    };
#endif /* INCLUDE_IO */
    
    struct sflashDesc PmemFlash =  {
#ifdef INCLUDE_IO 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_PMEM, 
        ioctlFLASH_RAW_READ_PMEM, 
        ioctlFLASH_RAW_WRITE_PMEM,
        PMEM_FLASH_SIZE * sizeof(int) / PAGE_SIZE_P_IN_BYTES,  /* 128k words, dakar */
        /* PAGE_SIZE_P_IN_BYTES */ PAGE_SIZE_P_LOG + 1
    };

    struct sflashDesc XmemFlash = {
#ifdef INCLUDE_IO 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_XMEM,
        ioctlFLASH_RAW_READ_XMEM,
        ioctlFLASH_RAW_WRITE_XMEM,
        XMEM_FLASH_SIZE * sizeof(int) / PAGE_SIZE_IN_BYTES, /* 8k dakar */
        /* PAGE_SIZE_IN_BYTES */ PAGE_SIZE_LOG + 1
    };

    struct sflashDesc BootFlash = {
#ifdef INCLUDE_IO 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_BOOT, 
        ioctlFLASH_RAW_READ_BOOT, 
        ioctlFLASH_RAW_WRITE_BOOT,
        BOOT_FLASH_SIZE * sizeof(int) / PAGE_SIZE_IN_BYTES, /* 8k dakar */
       /* PAGE_SIZE_IN_BYTES */ PAGE_SIZE_LOG + 1
    };

    /* empirical formula for Flash divider */ 

#if PLL_MUL >= 31
#define FLASH_DIVIDER 19 /*	193.75 */
#elif PLL_MUL >= 30
#define FLASH_DIVIDER  18 /* 197.37 */
#elif PLL_MUL >= 28
#define FLASH_DIVIDER  17 /* 194.44 */
#elif PLL_MUL >= 26
#define FLASH_DIVIDER  16 /* 191.18 */
#elif PLL_MUL >= 25
#define FLASH_DIVIDER  15 /* 195.31 */
#elif PLL_MUL >= 23
#define FLASH_DIVIDER  14 /* 191.67 */
#elif PLL_MUL >= 21
#define FLASH_DIVIDER  13 /* 187.5 */
#elif PLL_MUL >= 20
#define FLASH_DIVIDER  12 /* 192.31 */
#elif PLL_MUL >= 18
#define FLASH_DIVIDER  11 /* 187.5 */
#elif PLL_MUL >= 17
#define FLASH_DIVIDER  10 /* 193.18 */
#elif PLL_MUL >= 15
#define FLASH_DIVIDER  9 /* 187.5 */
#elif PLL_MUL >= 13
#define FLASH_DIVIDER  9 /* 180.56 */
#elif PLL_MUL >= 12
#define FLASH_DIVIDER  7 /* 187.5 */
#elif PLL_MUL >= 9
#define FLASH_DIVIDER  6 /* 160.71 */
#elif PLL_MUL >= 7
#define FLASH_DIVIDER  4 /* 175 */
#elif PLL_MUL >= 5
#define FLASH_DIVIDER  3 /* 156.25 */
#elif PLL_MUL >= 4
#define FLASH_DIVIDER  2 /* 166.67 */
#else
#error incorrect PLL for flash programming
#endif 

// configured prescaler value 
const unsigned int flash_divider = (0x40 | FLASH_DIVIDER );

#endif 


// structure to save/restore peripheral registers power on reset state 
arch_PeriphRegState peripheralReg[archoff_registers_num] = {
	{archoff_FlexCAN + BSP_PERIPH_BASE, archoff_FlexCAN_length},
	{archoff_PortA  + BSP_PERIPH_BASE, archoff_PortA_length},
	{archoff_Sci0  + BSP_PERIPH_BASE, archoff_Sci0_length},
	{archoff_Sci1  + BSP_PERIPH_BASE, archoff_Sci1_length},
	{archoff_TimerA0  + BSP_PERIPH_BASE, archoff_TimerA0_length},
	{archoff_TimerB0 + BSP_PERIPH_BASE, archoff_TimerB0_length},
	{archoff_TimerC0 + BSP_PERIPH_BASE, archoff_TimerC0_length},
	{archoff_TimerD0 + BSP_PERIPH_BASE, archoff_TimerD0_length}
};

UWord16  RegState[archoff_FlexCAN_length + archoff_PortA_length + archoff_Sci0_length + \
    					archoff_Sci1_length + archoff_TimerA0_length + archoff_TimerB0_length + \
    					archoff_TimerC0_length + archoff_TimerD0_length ]  ;


