/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/config/instisr.c $ 
* $Author: saa $ 
* $Revision: /main/2 $ s
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:       SDK configurable ISRs prologs 
*
* Notes:  
*
******************************************************************************/

#include "port.h"
#include "bsp.h"
#include "arch.h" 
#include "arch_off.h" 
#include "scidrv.h"
#include "gpiodrv.h"

#define POUND  #
extern void Dispatcher(void);

extern void Sci0Tx_DispatchCallback(void);
extern void Sci1Tx_DispatchCallback(void);
extern void Sci0Rx_DispatchCallback(void);
extern void Sci1Rx_DispatchCallback(void);

/*******************************************************************************************/
#define ArchInstallISR(num, CallBack, prio)   \
void SDK_Interrupt##num(void);              \
void SDK_Interrupt##num(void)               \
{                                           \
    asm( alignsp );                         \
    asm( move.l  R0, x:(SP)+ );             \
    asm( move.l  POUND >>##CallBack  , R0 );\
    asm( jmp Dispatcher );                  \
}

#define ArchInstallFastISR(num, CallBack, prio)   \
void SDK_Interrupt##num(void);              \
void SDK_Interrupt##num(void)               \
{                                           \
    asm( jmp CallBack );                    \
}

#define ArchInstallCallBackISR(device,num, type, CallBack, prio)         	\
void SDK_Interrupt##num(void);                                              \
void SDK_Interrupt##num(void)                                               \
{                                                                           \
	asm(alignsp);														\
	asm(move.l	R2, X:(SP)+);												\
	asm(move.l	R3, X:(SP)+);												\
	asm(move.l	R4, X:(SP));												\
    asm(move.l POUND >>##device##DeviceContext, R3);                     	\
    asm(move.l POUND (BSP_PERIPH_BASE + archoff_##device), R2);           	\
    asm(move.l POUND >>##device##type##_DispatchCallback, R4);           	\
    asm(jsr	CallBack);													\
    asm(move.l X:(SP)-,R4);												\
    asm(move.l X:(SP)-,R3);												\
    asm(move.l X:(SP)-,R2);												\
    asm(move.l X:(SP)-,SP);												\
	asm(nop);					\
	asm(nop);					\
    asm(rti);																\
};

// include user and default configuration 
#include "config.h"

 