/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/include/bsp.h $ 
* $Author: saa $ 
* $Revision: /main/2 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:  Board Support Package
*
* Notes:     
*
******************************************************************************/

#ifndef __BSP_H
#define __BSP_H


#include "port.h"


#ifdef __cplusplus
extern "C" {
#endif

/* Supported board type. */


#if defined(DSP56838EVM)

/* Supported pheripheral adderess */
#define BSP_PERIPH_BASE  0xFFF000 
/* Supported pheripheral offset to use with arch adderess */
#define BSP_PERIPH_OFF  0xFFF000
/* Supported far pheripheral adderess */
#define BSP_FARPTR_PATCH


#elif defined (DSP56836EVM) || defined (DSP56832XEVM)

/* Supported pheripheral adderess */
#define BSP_PERIPH_BASE  0xF000
/* Supported pheripheral offset to use with arch adderess */
#define BSP_PERIPH_OFF  0

#else /* EVM */

#error "platform is not defined"

#endif /*  EVM */


/***************************************************************************
				P Interbal RAM circular buffer support
***************************************************************************/
#if defined (DSP56836XEVM)

#define BASE_CIRCULAR_BUFFER_ADDRESS	0x4FC00 /* Begin of P Int RAM */

#else

#define BASE_CIRCULAR_BUFFER_ADDRESS	0x2FC00 /* Begin of P Int RAM */

#endif

/* devices available for SDK Board Support Pakage, 
/* name shortcuts for driver "open" call */
/*    */


#define BSP_DEVICE_NAME_ADC_A      		((const char *)0x3A00)  /* ADC/A */
#define BSP_DEVICE_NAME_AN_A_0    		((const char *)0x3A10)  /* ADC/A/0 */
#define BSP_DEVICE_NAME_AN_A_1    		((const char *)0x3A11)  /* ADC/A/1 */
#define BSP_DEVICE_NAME_AN_A_2    		((const char *)0x3A12)  /* ADC/A/2 */
#define BSP_DEVICE_NAME_AN_A_3    		((const char *)0x3A13)  /* ADC/A/3 */
#define BSP_DEVICE_NAME_AN_A_4    		((const char *)0x3A14)  /* ADC/A/4 */
#define BSP_DEVICE_NAME_AN_A_5    		((const char *)0x3A15)  /* ADC/A/5 */
#define BSP_DEVICE_NAME_AN_A_6    		((const char *)0x3A16)  /* ADC/A/6 */
#define BSP_DEVICE_NAME_AN_A_7    		((const char *)0x3A17)  /* ADC/A/7 */

#define BSP_DEVICE_NAME_ADC_B      		((const char *)0x3A20)  /* ADC/B */
#define BSP_DEVICE_NAME_AN_B_0    		((const char *)0x3A30)  /* ADC/B/0 */
#define BSP_DEVICE_NAME_AN_B_1    		((const char *)0x3A31)  /* ADC/B/1 */
#define BSP_DEVICE_NAME_AN_B_2    		((const char *)0x3A32)  /* ADC/B/2 */
#define BSP_DEVICE_NAME_AN_B_3    		((const char *)0x3A33)  /* ADC/B/3 */
#define BSP_DEVICE_NAME_AN_B_4    		((const char *)0x3A34)  /* ADC/B/4 */
#define BSP_DEVICE_NAME_AN_B_5    		((const char *)0x3A35)  /* ADC/B/5 */
#define BSP_DEVICE_NAME_AN_B_6    		((const char *)0x3A36)  /* ADC/B/6 */
#define BSP_DEVICE_NAME_AN_B_7    		((const char *)0x3A37)  /* ADC/B/7 */
	/* Abstarct ADC deives */
#define BSP_DEVICE_NAME_0_ADC_PIN 		((const char *)0x3A40)  /* ADC/0 pin */
#define BSP_DEVICE_NAME_1_ADC_PIN 		((const char *)0x3A41)  /* ADC/1 pin */
#define BSP_DEVICE_NAME_2_ADC_PINS		((const char *)0x3A42)  /* ADC/2 pins */
#define BSP_DEVICE_NAME_3_ADC_PINS		((const char *)0x3A43)  /* ADC/3 pins */
#define BSP_DEVICE_NAME_4_ADC_PINS		((const char *)0x3A44)  /* ADC/4 pins */
#define BSP_DEVICE_NAME_5_ADC_PINS		((const char *)0x3A45)  /* ADC/5 pins */
#define BSP_DEVICE_NAME_6_ADC_PINS		((const char *)0x3A46)  /* ADC/6 pins */
#define BSP_DEVICE_NAME_7_ADC_PINS		((const char *)0x3A47)  /* ADC/7 pins */
#define BSP_DEVICE_NAME_8_ADC_PINS		((const char *)0x3A48)  /* ADC/8 pins */


#define BSP_DEVICE_NAME_FLASH_PMEM      ((const char *)0x3010)  /* FLASH/X */          
#define BSP_DEVICE_NAME_FLASH_XMEM      ((const char *)0x3020)  /* FLASH/P */    
#define BSP_DEVICE_NAME_FLASH_BOOT      ((const char *)0x3030)  /* FLASH/B */    

#define BSP_DEVICE_NAME_SERIAL_0        ((const char *)0x31A0)  /* SCI/0 */    
#define BSP_DEVICE_NAME_SCI_0           BSP_DEVICE_NAME_SERIAL_0      
#define BSP_DEVICE_NAME_SERIAL_1        ((const char *)0x31B0)  /* SCI/1 */    
#define BSP_DEVICE_NAME_SCI_1           BSP_DEVICE_NAME_SERIAL_1      

#define BSP_DEVICE_NAME_SPI_0           ((const char *)0x32A0)  /* SPI/0 */  	
#define BSP_DEVICE_NAME_SPI_1           ((const char *)0x32B0)  /* SPI/1 */  	

#define BSP_DEVICE_NAME_COP             ((const char *)0x33A0)  /* COP */    

#define BSP_DEVICE_NAME_CAN_0           ((const char *)0x34A0)  /* CAN/0 */    

#define BSP_DEVICE_NAME_PWM_A           ((const char *)0x35A0)  /* PWM/A 			*/
#define BSP_DEVICE_NAME_PWM_Ax1_0       ((const char *)0x35C0)  /* PWM/A_Chanel_0 		*/
#define BSP_DEVICE_NAME_PWM_Ax1_1       ((const char *)0x35C1)  /* PWM/A_Chanel_1 		*/
#define BSP_DEVICE_NAME_PWM_Ax1_2       ((const char *)0x35C2)  /* PWM/A_Chanel_2 		*/
#define BSP_DEVICE_NAME_PWM_Ax1_3       ((const char *)0x35C3)  /* PWM/A_Chanel_3 		*/
#define BSP_DEVICE_NAME_PWM_Ax1_4       ((const char *)0x35C4)  /* PWM/A_Chanel_4 		*/
#define BSP_DEVICE_NAME_PWM_Ax1_5       ((const char *)0x35C5)  /* PWM/A_Chanel_5 		*/
#define BSP_DEVICE_NAME_PWM_Ax2_0       ((const char *)0x35C6)  /* PWM/A_Chanel_01 		*/
#define BSP_DEVICE_NAME_PWM_Ax2_1       ((const char *)0x35C7)  /* PWM/A_Chanel_23 		*/
#define BSP_DEVICE_NAME_PWM_Ax2_2       ((const char *)0x35C8)  /* PWM/A_Chanel_45 		*/
#define BSP_DEVICE_NAME_PWM_Ax3_0       ((const char *)0x35C9)  /* PWM/A_Chanel_012 	*/
#define BSP_DEVICE_NAME_PWM_Ax3_1       ((const char *)0x35CA)  /* PWM/A_Chanel_345 	*/
#define BSP_DEVICE_NAME_PWM_Ax6_0       ((const char *)0x35CB)  /* PWM/A_Chanel_012345 	*/

#define BSP_DEVICE_NAME_PWM_B           ((const char *)0x35B0)  /* PWM/B 			*/
#define BSP_DEVICE_NAME_PWM_Bx1_0       ((const char *)0x35D0)  /* PWM/B_Chanel_0 		*/
#define BSP_DEVICE_NAME_PWM_Bx1_1       ((const char *)0x35D1)  /* PWM/B_Chanel_1 		*/
#define BSP_DEVICE_NAME_PWM_Bx1_2       ((const char *)0x35D2)  /* PWM/B_Chanel_2 		*/
#define BSP_DEVICE_NAME_PWM_Bx1_3       ((const char *)0x35D3)  /* PWM/B_Chanel_3 		*/
#define BSP_DEVICE_NAME_PWM_Bx1_4       ((const char *)0x35D4)  /* PWM/B_Chanel_4 		*/
#define BSP_DEVICE_NAME_PWM_Bx1_5       ((const char *)0x35D5)  /* PWM/B_Chanel_5 		*/
#define BSP_DEVICE_NAME_PWM_Bx2_0       ((const char *)0x35D6)  /* PWM/B_Chanel_01 		*/
#define BSP_DEVICE_NAME_PWM_Bx2_1       ((const char *)0x35D7)  /* PWM/B_Chanel_23 		*/
#define BSP_DEVICE_NAME_PWM_Bx2_2       ((const char *)0x35D8)  /* PWM/B_Chanel_45 		*/
#define BSP_DEVICE_NAME_PWM_Bx3_0       ((const char *)0x35D9)  /* PWM/B_Chanel_012 	*/
#define BSP_DEVICE_NAME_PWM_Bx3_1       ((const char *)0x35DA)  /* PWM/B_Chanel_345 	*/
#define BSP_DEVICE_NAME_PWM_Bx6_0       ((const char *)0x35DB)  /* PWM/B_Chanel_012345 	*/

#define BSP_DEVICE_NAME_DECODER_0       ((const char *)0x36A0)  /* DEC/0 */

#define BSP_DEVICE_NAME_GPIO_A          ((const char *)0x37A0)  /* GPIO/A */    
#define BSP_DEVICE_NAME_GPIO_A_PIN0     ((const char *)0x37A1)  /* GPIO/A/0 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN1     ((const char *)0x37A2)  /* GPIO/A/1 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN2     ((const char *)0x37A3)  /* GPIO/A/2 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN3     ((const char *)0x37A4)  /* GPIO/A/3 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN4     ((const char *)0x37A5)  /* GPIO/A/4 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN5     ((const char *)0x37A6)  /* GPIO/A/5 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN6     ((const char *)0x37A7)  /* GPIO/A/6 */    
#define BSP_DEVICE_NAME_GPIO_A_PIN7     ((const char *)0x37A8)  /* GPIO/A/7 */    
#define BSP_DEVICE_NAME_GPIO_B          ((const char *)0x37B0)  /* GPIO/B */    
#define BSP_DEVICE_NAME_GPIO_B_PIN0     ((const char *)0x37B1)  /* GPIO/B/0 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN1     ((const char *)0x37B2)  /* GPIO/B/1 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN2     ((const char *)0x37B3)  /* GPIO/B/2 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN3     ((const char *)0x37B4)  /* GPIO/B/3 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN4     ((const char *)0x37B5)  /* GPIO/B/4 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN5     ((const char *)0x37B6)  /* GPIO/B/5 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN6     ((const char *)0x37B7)  /* GPIO/B/6 */    
#define BSP_DEVICE_NAME_GPIO_B_PIN7     ((const char *)0x37B8)  /* GPIO/B/7 */    
#define BSP_DEVICE_NAME_GPIO_C          ((const char *)0x37C0)  /* GPIO/C */    
#define BSP_DEVICE_NAME_GPIO_C_PIN0     ((const char *)0x37C1)  /* GPIO/C/0 */    
#define BSP_DEVICE_NAME_GPIO_C_PIN1     ((const char *)0x37C2)  /* GPIO/C/1 */    
#define BSP_DEVICE_NAME_GPIO_C_PIN2     ((const char *)0x37C3)  /* GPIO/C/2 */    
#define BSP_DEVICE_NAME_GPIO_C_PIN3     ((const char *)0x37C4)  /* GPIO/C/3 */    
#define BSP_DEVICE_NAME_GPIO_D          ((const char *)0x37D0)  /* GPIO/D */    
#define BSP_DEVICE_NAME_GPIO_D_PIN0     ((const char *)0x37D1)  /* GPIO/D/0 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN1     ((const char *)0x37D2)  /* GPIO/D/1 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN2     ((const char *)0x37D3)  /* GPIO/D/2 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN3     ((const char *)0x37D4)  /* GPIO/D/3 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN4     ((const char *)0x37D5)  /* GPIO/D/4 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN5     ((const char *)0x37D6)  /* GPIO/D/5 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN6     ((const char *)0x37G7)  /* GPIO/D/6 */    
#define BSP_DEVICE_NAME_GPIO_D_PIN7     ((const char *)0x37D8)  /* GPIO/D/7 */    
#define BSP_DEVICE_NAME_GPIO_E          ((const char *)0x37E0)  /* GPIO/E */    
#define BSP_DEVICE_NAME_GPIO_E_PIN0     ((const char *)0x37E1)  /* GPIO/E/0 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN1     ((const char *)0x37E2)  /* GPIO/E/1 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN2     ((const char *)0x37E3)  /* GPIO/E/2 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN3     ((const char *)0x37E4)  /* GPIO/E/3 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN4     ((const char *)0x37E5)  /* GPIO/E/4 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN5     ((const char *)0x37E6)  /* GPIO/E/5 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN6     ((const char *)0x37E7)  /* GPIO/E/6 */    
#define BSP_DEVICE_NAME_GPIO_E_PIN7     ((const char *)0x37E8)  /* GPIO/E/7 */    

#define BSP_DEVICE_NAME_LED_0           ((const char *)0x38A0)  /* LED/A */    
#define BSP_DEVICE_NAME_LED_RED         ((const char *)0x38A1)  /* LED/A/0 */    
#define BSP_DEVICE_NAME_LED_YELLOW      ((const char *)0x38A2)  /* LED/A/1 */    
#define BSP_DEVICE_NAME_LED_GREEN       ((const char *)0x38A3)  /* LED/A/2 */    
#define BSP_DEVICE_NAME_LED_RED2        ((const char *)0x38A4)  /* LED/A/3 */    
#define BSP_DEVICE_NAME_LED_YELLOW2     ((const char *)0x38A5)  /* LED/A/4 */    
#define BSP_DEVICE_NAME_LED_GREEN2      ((const char *)0x38A6)  /* LED/A/5 */    

#define BSP_DEVICE_NAME_LED_PWM     	((const char *)0x38B0)  /* LED/B */     
#define BSP_DEVICE_NAME_LED_PWM_1     	((const char *)0x38B1)  /* LED/B/0 */     
#define BSP_DEVICE_NAME_LED_PWM_2     	((const char *)0x38B2)  /* LED/B/1 */     
#define BSP_DEVICE_NAME_LED_PWM_3     	((const char *)0x38B3)  /* LED/B/2 */     
#define BSP_DEVICE_NAME_LED_PWM_4     	((const char *)0x38B4)  /* LED/B/3 */     
#define BSP_DEVICE_NAME_LED_PWM_5     	((const char *)0x38B5)  /* LED/B/4 */     
#define BSP_DEVICE_NAME_LED_PWM_6     	((const char *)0x38B6)  /* LED/B/5 */     

#define BSP_DEVICE_NAME_SWITCH_0        ((const char *)0x39A0)  /* SWITCH/0 */    
#define BSP_DEVICE_NAME_BUTTON_A        ((const char *)0x39B0)  /* BUTTON/A */    
#define BSP_DEVICE_NAME_BUTTON_B        ((const char *)0x39C0)  /* BUTTON/B */    

#define BSP_DEVICE_NAME_DAC_A           ((const char *)0x3DA0)  /* DAC/A */     
#define BSP_DEVICE_NAME_DAC_B           ((const char *)0x3DB0)  /* DAC/B */     
#define BSP_DEVICE_NAME_DAC_C           ((const char *)0x3DC0)  /* DAC/C */     
#define BSP_DEVICE_NAME_DAC_D           ((const char *)0x3DD0)  /* DAC/D */     

#ifdef __cplusplus
}
#endif

#endif

