/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/include/io.h $ 
* $Author: saa $ 
* $Revision: /main/2 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:  POSIX interface support to peripheral devices
*
* Notes:          
*
******************************************************************************/


#ifndef __HIGHLEVELMAPPING_H
#define __HIGHLEVELMAPPING_H


#include "port.h"
#include "stdlib.h"
#include "sci.h"
#include "flexcan.h"
#include "appconfig.h"


#ifdef __cplusplus
extern "C" {
#endif

#ifdef INCLUDE_SCI

#define OPEN(DeviceName, OFlags, Parameters)    OPENSCI(DeviceName, OFlags, Parameters) 
#define READ(FD, Buffer, Size)                  READSCI(FD, Buffer, Size)
#define WRITE(FD, Buffer, Size)                 WRITESCI(FD, Buffer, Size)
#define IOCTL(FD, Cmd)                          IOCTLSCIGET_BUFFER_STATUS(FD)                                       
#define CLOSE(FD)                               CLOSESCI(FD)

// SCI low-level mapping
#define OPENSCI(DeviceName, OFlags, Parameters) \
		sciOpen((const char *) DeviceName, (int) OFlags, (unsigned long) Parameters)   

#define READSCI(FD, Buffer, Size)  \
		sciBlockRead((handle_t) FD, (void *) Buffer, (size_t) Size);

#define WRITESCI(FD, Buffer, Size)  \
		sciBlockWrite((handle_t) FD, (void *) Buffer, (size_t) Size);

#define IOCTLSCIGET_BUFFER_STATUS(FD)  \
		sciIoctlSCI_GET_COUNT_READ((handle_t) FD, (unsigned long) NULL)
		
#define CLOSESCI(FD) \
		sciClose((handle_t) FD)		

#endif

#ifdef INCLUDE_CAN

#define OPEN(DeviceName, OFlags, Parameters)    OPENCAN(DeviceName, OFlags, Parameters) 
#define READ(FD, Buffer, Size)                  READCAN(FD, Buffer, Size)
#define WRITE(FD, Buffer, Size)                 WRITECAN(FD, Buffer, Size)
#define IOCTL(FD, Cmd)                          IOCTLCANGET_BUFFER_STATUS(FD)                                       
#define CLOSE(FD)                               CLOSECAN(FD)

// CAN low-level mapping
#define OPENCAN(DeviceName, OFlags, Parameters) \
		flexcanOpen((const char *) DeviceName, (int) 0, (unsigned long) 0) \

#define READCAN(FD, Buffer, Size)  \
		flexcanRead((handle_t)FD, (void *) Buffer, (size_t) Size)

#define WRITECAN(FD, Buffer, Size)  \
		flexcanWrite((handle_t)FD,  (const void *)Buffer, (size_t) Size)

#define IOCTLCANGET_BUFFER_STATUS(FD)  \
		ioctlCANID_GET_STATUS((handle_t)FD, 0)

#define CLOSECAN(FD) \
		flexcanClose((handle_t) FD)
#endif

#ifdef __cplusplus
}
#endif

#endif
