/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/config/configdefines.h $ 
* $Author: saa $ 
* $Revision: /main/2 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:  configuration of SDK application  
*
* Notes:   
*
******************************************************************************/
#ifndef __CONFIGDEFINES_H
#define __CONFIGDEFINES_H

/* not C++ */
/*#ifdef __cplusplus
extern "C" {
#endif
*/

#if !defined(ArchInstallCallback)
	#define ArchInstallCallback(__A, __B, __C)
#endif

#if !defined(ArchQuadCallBackOnCpmpare)
	#define ArchQuadCallBackOnCpmpare(__A,__B,__C)
#endif

#if !defined(ArchQuadCallBackOnInputEdge)
	#define ArchQuadCallBackOnInputEdge(__A,__B,__C)
#endif

#if !defined(ArchQuadCallBackOnOverflow)
	#define ArchQuadCallBackOnOverflow(__A,__B,__C)
#endif

#if !defined( ArchInstallISR )
	#define ArchInstallISR( num, CallBack, prio )
#endif
#if !defined( ArchInstallFastISR )
	#define ArchInstallFastISR( num, CallBack, prio )
#endif

#if !defined( ArchInstallSuperFastISR0 )
	#define ArchInstallSuperFastISR0( num, CallBack )
#endif

#if !defined( ArchInstallSuperFastISR1 )
	#define ArchInstallSuperFastISR1( num, CallBack )
#endif

#if !defined( ArchInstallTimerISR )
    #define ArchInstallTimerISR( num, tmr, chnl, prio )  
#endif /* !defined( ArchInstallTimerISR ) */

#if !defined( ArchInstallADCErrorCallBackISR )
    #define ArchInstallADCErrorCallBackISR(device, num, CallBack, prio )
#endif /* !defined( ArchInstallADCErrorCallBackISR ) */

#if !defined( ArchInstallGPIOISR )
    #define ArchInstallGPIOISR( num, tmr, chnl) 
#endif /* !defined( ArchInstallGPIOISR ) */

/****************************************************************************
*
* Include user selected SDK components
*
****************************************************************************/
#include "appconfig.h"

/****************************************************************************
*
* Resolve include dependencies automatically
*
****************************************************************************/

/* public SDK constans ( default value ) */
#if !defined( PLL_MUL )
	#define PLL_MUL 30
#endif /* !defined( PLL_MUL ) */

#if !defined(PMEM_WAIT_STATE)
	#define PMEM_WAIT_STATE   1
#endif /* !defined(INCLUDE_ITCN) */

#if !defined(XMEM_WAIT_STATE)
	#define XMEM_WAIT_STATE   1
#endif /* !defined(INCLUDE_ITCN) */

#if defined( INCLUDE_BSP )

	#if !defined(INCLUDE_PLL)
		#define INCLUDE_PLL
	#endif /* !defined(INCLUDE_PLL) */

	#if !defined(INCLUDE_ITCN)
		#define INCLUDE_ITCN
	#endif /* !defined(INCLUDE_ITCN) */

	#if !defined(INCLUDE_ITCN)
		#define INCLUDE_ITCN
	#endif /* !defined(INCLUDE_ITCN) */

#endif

#ifdef INCLUDE_IO
	
	#if !defined(INCLUDE_IO_LED)
		#define INCLUDE_IO_LED
	#endif /* !defined(INCLUDE_IO_LED) */
	#if !defined(INCLUDE_IO_GPIO)
		#define INCLUDE_IO_GPIO
	#endif /* !defined(INCLUDE_IO_GPIO) */
	#if !defined(INCLUDE_IO_SCI)
		#define INCLUDE_IO_SCI
	#endif

#endif

#if defined(INCLUDE_DAC)

	#if !defined(INCLUDE_SPI)
		#define INCLUDE_SPI
	#endif
	
#endif  /* INCLUDE_DAC */

#ifdef INCLUDE_BUTTON
	#if !defined (INCLUDE_TIMER)
		#define INCLUDE_TIMER
//		        ArchSetTimer( A, 0 );
	#endif

#endif /* INCLUDE_BUTTON */



#if defined(DSP56838EVM)


#if defined( INCLUDE_TIMER )

        ArchInstallTimerISR( 60, A, 0, 2 );
        ArchInstallTimerISR( 61, A, 1, 2 );
        ArchInstallTimerISR( 62, A, 2, 2 );
        ArchInstallTimerISR( 63, A, 3, 2 );

        ArchInstallTimerISR( 56, C, 0, 2 );
        ArchInstallTimerISR( 57, C, 1, 2 );
        ArchInstallTimerISR( 58, C, 2, 2 );
        ArchInstallTimerISR( 59, C, 3, 2 );

        ArchInstallTimerISR( 52, D, 0, 2 );
        ArchInstallTimerISR( 53, D, 1, 2 );
        ArchInstallTimerISR( 54, D, 2, 2 );
        ArchInstallTimerISR( 55, D, 3, 2 );           
	
#endif /* defined(INCLUDE_TIMER) */

#if defined( INCLUDE_MSCAN )
	
		ArchInstallISR( 26, CANSendISR, 1 );
		
		ArchInstallISR( 29, CANReceiveISR, 1 );			
		
		ArchInstallISR( 28, CANWakeUpISR, 1 );	
		
		ArchInstallISR( 27, CANErrorISR, 1 );			

#endif /* defined(INCLUDE_MSCAN) */

#if defined (INCLUDE_PWM)
		ArchInstallCallBackISR(PwmB, 73, Reload, pwm_Reload_ISR, 1);
		ArchInstallCallBackISR(PwmA, 74, Reload, pwm_Reload_ISR, 1);
		ArchInstallCallBackISR(PwmB, 75, Fault, pwm_Fault_ISR, 1);
		ArchInstallCallBackISR(PwmA, 76, Fault, pwm_Fault_ISR, 1);

#endif /* defined (INCLUDE_PWM) */

#if defined( INCLUDE_BUTTON )
        ArchInstallCallBackISR(ButtonA, 17, any, buttonISR, 1);
        ArchInstallCallBackISR(ButtonB, 18, any, buttonISR, 1);
#endif /* defined( INCLUDE_BUTTON ) */


#if defined( INCLUDE_SPI )
	
		ArchInstall4CallBackISR(Spi0,41,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1); /* SPI0 transmitter empty interrupt handler */
		ArchInstall4CallBackISR(Spi1,39,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1);	/* SPI1 transmitter empty interrupt handler */

		ArchInstall4CallBackISR(Spi0,40,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1); /* SPI0 receiver full interrupt handler */
		ArchInstall4CallBackISR(Spi1,38,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1);	/* SPI1 receiver full interrupt handler */		

#endif	/* INCLUDE_SPI */

#if defined( INCLUDE_SCI )

        ArchInstallCallBackISR(Sci0,64,Tx, sciTransmitterISR, 2);
        ArchInstallCallBackISR(Sci0,65,Tx, sciTransmitterISR, 2);    
        ArchInstallCallBackISR(Sci0,66,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci0,67,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci0,68,Rx, sciReceiverISR, 2);    
    
	    ArchInstallCallBackISR(Sci1,42,Tx, sciTransmitterISR, 2);
   	    ArchInstallCallBackISR(Sci1,43,Tx, sciTransmitterISR, 2);
        ArchInstallCallBackISR(Sci1,44,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci1,45,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci1,46,Rx, sciReceiverISR, 2);    

#endif /* defined( INCLUDE_SCI ) */

#if defined( INCLUDE_DECODER )

        ArchInstallCallBackISR(Decoder0, 49, HomeWatchdog, decoderHomeWatchdog0ISR, 1);
   	    ArchInstallCallBackISR(Decoder0, 50, Index, decoderIndex0ISR, 1);

#endif /* defined( INCLUDE_DECODER ) */

#if defined( INCLUDE_GPIO )

        ArchInstallGPIOISR( 34, A, 1 );
		ArchInstallGPIOISR( 33, B, 1 );
		ArchInstallGPIOISR( 32, C, 1 );
		ArchInstallGPIOISR( 31, D, 1 );
		ArchInstallGPIOISR( 30, E, 1 );

#endif /* defined( INCLUDE_GPIO ) */

#if defined( INCLUDE_ADC )

		ArchInstallCallBackISR(AdcB, 69, Complete, adcConversionCompleteISR,1);
		ArchInstallCallBackISR(AdcA, 70, Complete, adcConversionCompleteISR,1);

        ArchInstallADCErrorCallBackISR(AdcB, 71, adcErrorISR, 1);
        ArchInstallADCErrorCallBackISR(AdcA, 72, adcErrorISR, 1);

#endif /*defined( INCLUDE_ADC ) */


#else /* defined(DSP56838EVM) */


#if defined( INCLUDE_TIMER )

        ArchInstallTimerISR( 52, D, 0, 2 );
        ArchInstallTimerISR( 53, D, 1, 2 );
        ArchInstallTimerISR( 54, D, 2, 2 );
        ArchInstallTimerISR( 55, D, 3, 2 );

        ArchInstallTimerISR( 56, C, 0, 2 );
        ArchInstallTimerISR( 57, C, 1, 2 );
        ArchInstallTimerISR( 58, C, 2, 2 );
        ArchInstallTimerISR( 59, C, 3, 2 );

        ArchInstallTimerISR( 60, B, 0, 2 );
        ArchInstallTimerISR( 61, B, 1, 2 );
        ArchInstallTimerISR( 62, B, 2, 2 );
        ArchInstallTimerISR( 63, B, 3, 2 );

        ArchInstallTimerISR( 64, A, 0, 2 );
        ArchInstallTimerISR( 65, A, 1, 2 );
        ArchInstallTimerISR( 66, A, 2, 2 );
        ArchInstallTimerISR( 67, A, 3, 2 );
	
	
#endif /* defined(INCLUDE_TIMER) */

#if defined( INCLUDE_FLEXCAN )
	
		ArchInstallFastISR( 29, CANBufferISR, 1 );			

#endif /* defined(INCLUDE_FLEXCAN) */

#if defined (INCLUDE_PWM)

		ArchInstallCallBackISR(PwmB, 77, Reload, pwm_Reload_ISR, 1);
		ArchInstallCallBackISR(PwmA, 78, Reload, pwm_Reload_ISR, 1);
		ArchInstallCallBackISR(PwmB, 79, Fault, pwm_Fault_ISR, 1);
		ArchInstallCallBackISR(PwmA, 80, Fault, pwm_Fault_ISR, 1);

#endif /* defined (INCLUDE_PWM) */

#if defined( INCLUDE_BUTTON )
        ArchInstallCallBackISR(ButtonA, 17, any, buttonISR, 1);
        ArchInstallCallBackISR(ButtonB, 18, any, buttonISR, 1);
#endif /* defined( INCLUDE_BUTTON ) */


#if defined( INCLUDE_SPI )
	
		ArchInstall4CallBackISR(Spi0,41,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1); /* SPI0 transmitter empty interrupt handler */
		ArchInstall4CallBackISR(Spi1,39,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1);	/* SPI1 transmitter empty interrupt handler */

		ArchInstall4CallBackISR(Spi0,40,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1); /* SPI0 receiver full interrupt handler */
		ArchInstall4CallBackISR(Spi1,38,ChipSelect,ChipDeselect,Tx,Rx,spiISRHandler,1);	/* SPI1 receiver full interrupt handler */		

#endif	/* INCLUDE_SPI */

#if defined( INCLUDE_SCI )

        ArchInstallCallBackISR(Sci0,68,Tx, sciTransmitterISR, 2);
        ArchInstallCallBackISR(Sci0,69,Tx, sciTransmitterISR, 2);    
        ArchInstallCallBackISR(Sci0,70,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci0,71,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci0,72,Rx, sciReceiverISR, 2);    
    
	    ArchInstallCallBackISR(Sci1,42,Tx, sciTransmitterISR, 2);
   	    ArchInstallCallBackISR(Sci1,43,Tx, sciTransmitterISR, 2);
        ArchInstallCallBackISR(Sci1,44,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci1,45,Rx, sciReceiverISR, 2);    
        ArchInstallCallBackISR(Sci1,46,Rx, sciReceiverISR, 2);    

#endif /* defined( INCLUDE_SCI ) */

#if defined( INCLUDE_DECODER )

        ArchInstallCallBackISR(Decoder0, 49, HomeWatchdog, decoderHomeWatchdog0ISR, 1);
   	    ArchInstallCallBackISR(Decoder0, 50, Index, decoderIndex0ISR, 1);

#endif /* defined( INCLUDE_DECODER ) */

#if defined( INCLUDE_GPIO )

        ArchInstallGPIOISR( 34, A, 1 );
		ArchInstallGPIOISR( 33, B, 1 );
		ArchInstallGPIOISR( 32, C, 1 );
		ArchInstallGPIOISR( 31, D, 1 );
		ArchInstallGPIOISR( 30, E, 1 );

#endif /* defined( INCLUDE_GPIO ) */

#if defined( INCLUDE_ADC )

		ArchInstallCallBackISR(AdcB, 73, Complete, adcConversionCompleteISR,1);
		ArchInstallCallBackISR(AdcA, 74, Complete, adcConversionCompleteISR,1);

        ArchInstallADCErrorCallBackISR(AdcB, 75, adcErrorISR, 1);
        ArchInstallADCErrorCallBackISR(AdcA, 76, adcErrorISR, 1);

#endif /*defined( INCLUDE_ADC ) */





#endif /* defined(DSP56838EVM) */




#endif	/* __CONFIGDEFINES_H	*/
