/*******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
* $Element: /project/dsp568_sdk/sdk/src/dsp56838evm/nos/config/const.c $ 
* $Author: saa $ 
* $Revision: /main/2 $ 
* $VOB: /project/dsp568_sdk $ 
* $OS: solaris $ 
*
* Description:       SDK configurable constant in Data Flash 
*
* Notes:  
*
******************************************************************************/
/* general header files  */
#include "port.h"
#include "arch.h"
#include "bsp.h"
#include "io.h"

/* driver dependent header files */
#include "pll.h"

#include "evmdrv.h"
#include "timerdrv.h"
#include "gpiodrv.h"
#include "scidrv.h"

#if defined(DSP56838EVM)
#include "mscan.h"
#else /* defined(DSP56838EVM) */
#include "flexcan.h"
#endif /* defined(DSP56838EVM) */


#include "flashdrv.h"
#include "arch_off.h"

//#define ArchSetTimer( tmr, chnl ) extern void SDK_stb(void)

#define ArchQuadCallBackOnCpmpare(tmr, chnl, CallBack ) extern void SDK_stb(void)   

#define ArchQuadCallBackOnOverflow(tmr, chnl, CallBack ) extern void SDK_stb(void)   

#define ArchQuadCallBackOnInputEdge(tmr, chnl, CallBack ) extern void SDK_stb(void)   

#define ArchInstallCallback(device, type, CallBack ) extern void SDK_stb(void)   

#define ArchInstall2CallBackISR(device,num, type1, type2,  CallBack, prio ) extern void SDK_stb(void)

#define ArchInstall4CallBackISR(device,num, type1, type2, type3, type4,  CallBack, prio ) extern void SDK_stb(void)

#define ArchInstallCallBackISR(device,num, type, CallBack, prio ) extern void SDK_stb(void)

#define ArchParameter(...) extern void SDK_stb(void)

/* include user and default configuration */
#include "config.h"

/*************************************STUB**************************************************/

void Sci0Tx_DispatchCallback(void);
void Sci0Tx_DispatchCallback(void){};

void Sci1Tx_DispatchCallback(void);
void Sci1Tx_DispatchCallback(void){};

void Sci0Rx_DispatchCallback(void);
void Sci0Rx_DispatchCallback(void){};

void Sci1Rx_DispatchCallback(void);
void Sci1Rx_DispatchCallback(void){};

void Spi0Rx_DispatchCallback(void);
void Spi0Rx_DispatchCallback(void){};

void Spi1Rx_DispatchCallback(void);
void Spi1Rx_DispatchCallback(void){};

void Spi0Tx_DispatchCallback(void);
void Spi0Tx_DispatchCallback(void){};

void Spi1Tx_DispatchCallback(void);
void Spi1Tx_DispatchCallback(void){};

void ButtonAany_DispatchCallback(void);
void ButtonAany_DispatchCallback(void){};

void ButtonBany_DispatchCallback(void);
void ButtonBany_DispatchCallback(void){};

void Decoder0HomeWatchdog_DispatchCallback(void);
void Decoder0HomeWatchdog_DispatchCallback(void){};

void Decoder0Index_DispatchCallback(void);
void Decoder0Index_DispatchCallback(void){};

void PwmAReload_DispatchCallback(void);
void PwmAReload_DispatchCallback(void){};

void PwmBReload_DispatchCallback(void);
void PwmBReload_DispatchCallback(void){};

void PwmAFault_DispatchCallback(void);
void PwmAFault_DispatchCallback(void){};

void PwmBFault_DispatchCallback(void);
void PwmBFault_DispatchCallback(void){};

void AdcAComplete_DispatchCallback(void);
void AdcAComplete_DispatchCallback(void){};
void AdcBComplete_DispatchCallback(void);
void AdcBComplete_DispatchCallback(void){};
void AdcAZeroCrossing_DispatchCallback(void);
void AdcAZeroCrossing_DispatchCallback(void){};
void AdcBZeroCrossing_DispatchCallback(void);
void AdcBZeroCrossing_DispatchCallback(void){};
void AdcALowLimit_DispatchCallback(void);
void AdcALowLimit_DispatchCallback(void){};
void AdcBLowLimit_DispatchCallback(void);
void AdcBLowLimit_DispatchCallback(void){};
void AdcAHighLimit_DispatchCallback(void);
void AdcAHighLimit_DispatchCallback(void){};
void AdcBHighLimit_DispatchCallback(void);
void AdcBHighLimit_DispatchCallback(void){};


/*****************************************************************************/
#if defined( INCLUDE_TIMER )

    /* reserve POSIX timer context */
	
	posix_tContext   posix_ctx_A_0;
	posix_tContext   posix_ctx_A_1;
	posix_tContext   posix_ctx_A_2;
	posix_tContext   posix_ctx_A_3;
	posix_tContext   posix_ctx_B_0;
	posix_tContext   posix_ctx_B_1;
	posix_tContext   posix_ctx_B_2;
	posix_tContext   posix_ctx_B_3;
	posix_tContext   posix_ctx_C_0;
	posix_tContext   posix_ctx_C_1;
	posix_tContext   posix_ctx_C_2;
	posix_tContext   posix_ctx_C_3;
	posix_tContext   posix_ctx_D_0;
	posix_tContext   posix_ctx_D_1;
	posix_tContext   posix_ctx_D_2;
	posix_tContext   posix_ctx_D_3;

    /* POSIX timer configuration table */

	const posix_tConfig posixDeviceMap[] =
	{  

		/****  Timer A     ****/
    		{ &ArchIO.TimerA.Channel0, &posix_ctx_A_0 },

    		{ &ArchIO.TimerA.Channel1, &posix_ctx_A_1 },

    		{ &ArchIO.TimerA.Channel2, &posix_ctx_A_2 },

   		 	{ &ArchIO.TimerA.Channel3, &posix_ctx_A_3 },

		/****   Timer B    ****/
#if !defined(DSP56838EVM)
    		{ &ArchIO.TimerB.Channel0, &posix_ctx_B_0 },

    		{ &ArchIO.TimerB.Channel1, &posix_ctx_B_1 },

    		{ &ArchIO.TimerB.Channel2, &posix_ctx_B_2 },

    		{ &ArchIO.TimerB.Channel3, &posix_ctx_B_3 },
#endif /* !defined(DSP56838EVM) */
		/****   Timer C     ****/
    		{ &ArchIO.TimerC.Channel0, &posix_ctx_C_0 },

    		{ &ArchIO.TimerC.Channel1, &posix_ctx_C_1 },

    		{ &ArchIO.TimerC.Channel2, &posix_ctx_C_2 },

    		{ &ArchIO.TimerC.Channel3, &posix_ctx_C_3 },

		/****   Timer D     ****/
    		{ &ArchIO.TimerD.Channel0, &posix_ctx_D_0 },

    		{ &ArchIO.TimerD.Channel1, &posix_ctx_D_1 },

    		{ &ArchIO.TimerD.Channel2, &posix_ctx_D_2 },

    		{ &ArchIO.TimerD.Channel3, &posix_ctx_D_3 },
    		
			{0,0}

	};
	const arch_sTimerChannel * realTimer =
	#if defined( SET_REAL_TIMER )
		 SET_REAL_TIMER;
	#else
		(&ArchIO.TimerA.Channel0);
	#endif
    /* protected  constants */
    
    /* work frequency*/
	const UWord32 	IP_BUS_FREQUENCY = BSP_OSCILLATOR_FREQ * PLL_MUL / 2 / 2;
	/* IP_BUS_FREQUENCY = IP_BUS_FREQUENCY_1 * IP_BUS_FREQUENCY_2 */
	const UWord32 	IP_BUS_FREQUENCY_1 = BSP_OSCILLATOR_FREQ * PLL_MUL / 2 / 2 / 10000;/**/
	const UWord32 	IP_BUS_FREQUENCY_2 = 10000;
		
    /* translate real time timer tick resolution to ns resolution => tick * 10^9 / IP_BUS_FREQUENCY =tick * (10^5 / IP_BUS_FREQUENCY_1)  = (tick * 10^2 / (IP_BUS_FREQUENCY_1 / 10^3)) */
    const UWord32 	REAL_TIME_TIMER_RESOLUTION = REAL_TICK_TIMER_RESOLUTION  * 100UL / (IP_BUS_FREQUENCY_1/1000UL);    
/*    const UWord32 	REAL_TIME_TIMER_RESOLUTION = REAL_TICK_TIMER_RESOLUTION * (BSP_OSCILLATOR_FREQ / 1000000UL) * PLL_MUL / 2 / 2 / 1000UL;    Wrong!*/
#if (REAL_TICK_TIMER_RESOLUTION <= 0xFFFF)
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 1;
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x1FFFE )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 1;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 2;
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x3FFFC )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 2;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 4;
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x7FFF8 )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 3;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 8;
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0xFFFF0 )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 4;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 16;
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x1FFFE0 )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 5;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 32;
        ,
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x3FFFC0 )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 6;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 64;

#elif (REAL_TICK_TIMER_RESOLUTION <= 0x7FFF80 )
	const UWord16 REAL_TIME_TIMER_STEP 		= REAL_TICK_TIMER_RESOLUTION << 7;
    const UWord16 REAL_TIME_TIMER_PRESCALER = 128;
#endif   
    
    const union sigval sig = {0}; /* non OS version */

    const qt_sQuadState timerStdFastStart = 
    {
	
	/* Control Reg				  */
	
    /*  OutputMode              :3*/	qtAssertWhileActive,	
    /*  CoChannelInitialize     :1*/	0,
    /*  CountDirection          :1*/	qtDown,
    /*  CountLength             :1*/	qtUntilCompare,
    /*  CountOnce	          	:1*/	qtRepeatedly,
    /*  SecondaryInputSource    :2*/	0,
    
#if (REAL_TICK_TIMER_RESOLUTION <= 0xFFFF)
    /*  InputSource 1 			:4*/    qtPrescalerDiv1,
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x1FFFE )
    /*  InputSource 1 			:4*/    qtPrescalerDiv2,
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x3FFFC )
    /*  InputSource 1 			:4*/    qtPrescalerDiv4,
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x7FFF8 )
    /*  InputSource 1 			:4*/    qtPrescalerDiv8,
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0xFFFF0 )
    /*  InputSource 1 			:4*/    qtPrescalerDiv16,
        
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x1FFFE0 )
    /*  InputSource 1 			:4*/    qtPrescalerDiv32,
        ,
#elif (REAL_TICK_TIMER_RESOLUTION <= 0x3FFFC0 )
    /*  InputSource 1 			:4*/    qtPrescalerDiv64,

#elif (REAL_TICK_TIMER_RESOLUTION <= 0x7FFF80 )
    /*  InputSource 1 			:4*/    qtPrescalerDiv128,
#endif
    
    /*  Mode                    :3*/	qtCount,
    /* status reg				  */
	/* 	OutputEnable            :1*/	1,
	/*	OutputPolarity          :1*/	qtNormal,
    /*  OutputOnMaster          :1*/	0,
    /*  Master                  :1*/    0,                                            
    /*  CaptureMode             :2*/	qtDisabled,
    /*  InputPolarity           :1*/	qtNormal,
	};

/*****************************************************************************/
#endif /* INCLUDE_TIMER */

#if defined( INCLUDE_LED )

typedef  UWord16(*ioctl_type)(handle_t , unsigned long params );	 

const io_sLEDInterface led_io = {no_read, ledWrite, no_close, 
{ ledIoctlLED_ON, ledIoctlLED_OFF, ledIoctlLED_TOGGLE , (ioctl_type)no_ioctl}};

const io_sLEDInterface led_io_general = {no_read, ledBarWrite, no_close, 
{ ledIoctlGLED_ON, ledIoctlGLED_OFF, ledIoctlGLED_TOGGLE,ledIoctlINVERT_DIRECTION}};


const io_sLEDInterface led_pwm_io = {no_read, ledPWMWrite, no_close, 
{ledIoctlPWMLED_ON, ledIoctlPWMLED_OFF, (ioctl_type)no_ioctl , (ioctl_type)no_ioctl}};

const io_sLEDInterface led_pwm_io_general = {no_read, ledPWMBarWrite, no_close, 
{ledIoctlPWMLED_ON, ledIoctlPWMLED_OFF, (ioctl_type)no_ioctl, ledPWMIoctlINVERT_DIRECTION }};

 
const led_Config ledPortMap[] =
{
			{(io_sInterface*)&led_io_general, 0 },
			
#if defined(DSP56838EVM)
			{(io_sInterface*)&led_io, &ArchIO.PortB,1<<1},
			{(io_sInterface*)&led_io, &ArchIO.PortB,1<<2},
			{(io_sInterface*)&led_io, &ArchIO.PortB,1<<3},
			
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<1},
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<2},
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<3}
#elif defined (DSP56836EVM) 

			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<0},
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<1},
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<2},
			
			{(io_sInterface*)&led_io, &ArchIO.PortC,1<<3},
			{(io_sInterface*)&led_io, &ArchIO.PortD,1<<6},
			{(io_sInterface*)&led_io, &ArchIO.PortD,1<<7}
#elif defined (DSP56832XEVM) 



#else /* EVM */
#error "platform is not defined"
#endif /*  EVM */


};








const led_PWM_Config ledPWMMap[] =
{
			{(io_sInterface*)&led_pwm_io_general, &ArchIO.PwmA,0},
			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0001},
			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0002},
			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0004},
			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0008},
			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0010},
 			{(io_sInterface*)&led_pwm_io, &ArchIO.PwmA,0x0020},						
};

const UWord16 sizeLedMap = sizeof(ledPortMap)/sizeof(ledPortMap[0]);	  
const UWord16 sizeLedPWMMap = sizeof(ledPWMMap)/sizeof(ledPWMMap[0]);
        
#endif /* INCLUDE_LED */

/******************************** ADC *****************************************************/
#if defined(INCLUDE_ADC)

#if defined(INCLUDE_IO)
	const  struct io_sAdcInterface adc_IO	 ={no_read , no_write , adcClose, ADC_IOCTL};
	const  struct io_sAdcInterface adc_PinBlockIO	 ={adcBlockRead , no_write , adcPinClose, NO_ADC_PIN_IOCTL};
	const  struct io_sAdcInterface adc_PinNonBlockIO  ={adcNonBlockRead , no_write , adcPinClose, NO_ADC_PIN_IOCTL};	
#else
	const  io_sInterface adc_IO	 ={noAdcBlockRead , noAdcBlockWrite , noAdcClose, noAdcIoctl};
	const  io_sInterface adc_PinBlockIO	 ={noAdcPinBlockRead , noAdcPinBlockWrite , noAdcPinClose, noAdcPinIoctl};
	const  io_sInterface adc_PinNonBlockIO  ={noAdcPinNonBlockRead , noAdcPinNonBlockWrite , noAdcPinClose, noAdcPinIoctl};	
	
#endif

	struct sAdcDevice AdcADeviceContext=
				{
					(io_sInterface *)&adc_IO,	/* IO interface 	*/
					archoff_AdcA,		/* ADC arch 		*/
					0,					/* nUsedSamples		*/
					0,					/* ZeroCrossing mask */
					0,					/* HL | LL mask */
					/* queue*/
					{
						0,				/* begin 			*/
						0,				/* end 				*/
						ADCA_BUF_MASK,	/* mask 			*/
						ADCA_BUF_OFFSET	/* offset 			*/
					},
					false				/* is not initialized*/
				};

	struct sAdcDevice AdcBDeviceContext=
				{
					(io_sInterface *)&adc_IO,	/* IO interface 	*/
					archoff_AdcB,		/* ADC arch 		*/
					0,					/* nUsedSamples		*/
					0,					/* ZeroCrossing mask */
					0,					/* HL | LL mask */
					/* queue*/
					{
						0,				/* begin 			*/
						0,				/* end 				*/
						ADCB_BUF_MASK,	/* mask 			*/
						ADCB_BUF_OFFSET	/* offset 			*/
					},
					false				/* is not initialized*/
				};
				
	struct sAdcAnalogInput ANAContexts[8];	/* Analog Input descriptors */
	struct sAdcAnalogInput ANBContexts[8];	/* Analog Input descriptors */
	

#endif /* INCLUDE_ADC*/

/*************************************************************************************/
#if defined(INCLUDE_SPI)

#if defined(INCLUDE_IO)
      
	const struct io_sSPIInterface spi_blockIO	 ={spiBlockRead, spiBlockWrite, spiClose,SPI_IOCTL};
	const struct io_sSPIInterface spi_nonblockIO ={spiNonBlockRead, spiNonBlockWrite, spiClose,SPI_IOCTL};
#else

	const  io_sInterface spi_blockIO	 ={noSpiBlockRead, noSpiBlockWrite, noSpiClose, noSpiIoctl};
	const  io_sInterface spi_nonblockIO  ={noSpiNonBlockRead, noSpiNonBlockWrite, noSpiClose, noSpiIoctl};
#endif

	struct sSPIDevice Spi0DeviceContext = { 	
								(io_sInterface *)&spi_nonblockIO,
								archoff_Spi0,			/*SPI Arch					*/
								{/* C3Buffer */
									0,								/* begin		*/
									0,								/* marker		*/
									0,								/* end			*/
									SPI0_BUF_MASK,	/* mask			*/
									SPI0_BUF_OFFSET,				/*  buffer offset		*/
								}
							};
							
	struct sSPIDevice Spi1DeviceContext = { 	
								(io_sInterface *)&spi_nonblockIO,
								archoff_Spi1,			/*SPI Arch					*/
								{/* C3Buffer */
									0,								/* begin		*/
									0,								/* marker			*/
									0,								/* end		*/
									SPI1_BUF_MASK,	/* mask			*/
									SPI1_BUF_OFFSET					/* buffer offset */
								}
							};


#endif /* INCLUDE_SPI */

#if defined(INCLUDE_DAC)

#if defined (INCLUDE_IO)

    const struct io_sDACInterface dac_nonblockIO = {dacBlockRead , dacBlockWrite , dacClose , DAC_IOCTL};
    const struct io_sDACInterface dac_blockIO = {dacNonBlockRead , dacNonBlockWrite , dacClose , DAC_IOCTL};
#else

    const io_sInterface dac_blockIO 	= {noDacBlockRead, noDacBlockWrite, noDacClose, noDacIoctl};
    const io_sInterface dac_nonblockIO 	= {noDacNonBlockRead, noDacNonBlockWrite, noDacClose, noDacIoctl};
#endif

    struct sDACDevice DacADeviceContext = 
    						{
    							(io_sInterface*)&dac_nonblockIO, 
    							{DAC_A , DAC_CHANNEL_A, 0 , 0 , NULL}
    						};
    						
    struct sDACDevice DacBDeviceContext = 
    						{
    							(io_sInterface*)&dac_nonblockIO, 
    							{DAC_B , DAC_CHANNEL_B, 0 , 0 , NULL}
    						};
    						
    struct sDACDevice DacCDeviceContext = 
    						{
    							(io_sInterface*)&dac_nonblockIO, 
    							{DAC_C , DAC_CHANNEL_C, 0 , 0 , NULL}
    						};

    struct sDACDevice DacDDeviceContext = 
    						{
    							(io_sInterface*)&dac_nonblockIO, 
    							{DAC_D , DAC_CHANNEL_D, 0 , 0 , NULL}
    						};
#endif /* INCLUDE_DAC */


/*****************************************************************************/

#if defined( INCLUDE_PWM )

#if defined(INCLUDE_IO)

#define PWM_IOCTLS {															\
				ioctlPWM_DEVICE_ENABLE,				ioctlPWM_DEVICE_DISABLE,	\
				ioctlPWM_OUTPUT_PAD_ENABLE,			ioctlPWM_OUTPUT_PAD_DISABLE,\
				ioctlPWM_READ_FAULT_STATUS_REG,		ioctlPWM_READ_COUNTER_REG,	\
				ioctlPWM_READ_CONTROL_REG,			ioctlPWM_READ_PORT_REG,		\
				ioctlPWM_SET_CURRENT_SENSING,		ioctlPWM_SET_LOAD_MODE,		\
				ioctlPWM_OUTPUT_SOFTWARE_CONTROL,	ioctlPWM_OUTPUT_CONTROL,	\
				ioctlPWM_SET_SWAP,					ioctlPWM_SET_CHANNEL_MASK	\
		}
		
	const struct io_sPWMInterface pwm_IO	={noPwmBlockRead, noPwmBlockWrite, pwmClose, PWM_IOCTLS};
#else

	const			io_sInterface pwm_IO	={noPwmBlockRead, noPwmBlockWrite, noPwmBlockClose, noPwmIoctl};
#endif

	/* clock = ms * IP_BUS_FREQ / 10^6  = ms * MICRO_IP_BUS_FREQUENCY */
	const UWord32 MICRO_IP_BUS_FREQUENCY = (UWord32) BSP_OSCILLATOR_FREQ * PLL_MUL / 2 / 2 / 1000000;

	 struct sPwmDevice PwmADeviceContext =
		{
			(io_sInterface *)&pwm_IO,
			archoff_PwmA,
			{
				/*	volatile	unsigned 	int		begin			=	*/ 0,
				/*	volatile	unsigned 	int		end				=	*/ 0,
				/*	volatile	unsigned	int		mask			=	*/ PWMA_BUF_MASK,
				/*	volatile	unsigned	int		bufferOffset	=	*/ PWMA_BUF_OFFSET,
				/*				unsigned	long	reserved		=	*/ 0
			},
			0
		};
#if defined (BSP_DEVICE_NAME_PWM_B)
	 struct sPwmDevice PwmBDeviceContext =
		{
			(io_sInterface *)&pwm_IO,
			archoff_PwmB,
			{
				/*	volatile	unsigned 	int		begin			=	*/ 0,
				/*	volatile	unsigned 	int		end				=	*/ 0,
				/*	volatile	unsigned	int		mask			=	*/ PWMB_BUF_MASK,
				/*	volatile	unsigned	int		bufferOffset	=	*/ PWMB_BUF_OFFSET,
				/*				unsigned	long	reserved		=	*/ 0
			},
			0
		};
#endif

#if defined(INCLUDE_IO)
	const struct io_sPWMInterface pwm_channel_blockIO	 ={noPwmBlockRead, pwmBlockWrite, pwmChannelClose, noPwmIoctl};
	const struct io_sPWMInterface pwm_channel_nonblockIO ={noPwmNonBlockRead, pwmNonBlockWrite, pwmChannelClose, noPwmIoctl};
#else
	const  io_sInterface pwm_channel_blockIO	 ={noPwmBlockRead, noPwmBlockWrite, noPwmBlockClose, noPwmIoctl};
	const  io_sInterface pwm_channel_nonblockIO  ={noPwmNonBlockRead, noPwmNonBlockWrite, noPwmBlockClose, noPwmIoctl};
#endif

	struct sPwmChannel PwmChannel[] =
	{
#ifdef BSP_DEVICE_NAME_PWM_A
		{ NULL, &PwmADeviceContext, 1, 1, 0, 0x0001},
		{ NULL, &PwmADeviceContext, 1, 2, 0, 0x0002},
		{ NULL, &PwmADeviceContext, 1, 3, 0, 0x0004},
		{ NULL, &PwmADeviceContext, 1, 4, 0, 0x0008},
		{ NULL, &PwmADeviceContext, 1, 5, 0, 0x0010},
		{ NULL, &PwmADeviceContext, 1, 6, 0, 0x0020},
		{ NULL, &PwmADeviceContext, 2, 1, 0, 0x0003},
		{ NULL, &PwmADeviceContext, 2, 3, 0, 0x000C},
		{ NULL, &PwmADeviceContext, 2, 5, 0, 0x0030},
		{ NULL, &PwmADeviceContext, 3, 1, 0, 0x0007},
		{ NULL, &PwmADeviceContext, 3, 4, 0, 0x0038},
		{ NULL, &PwmADeviceContext, 6, 1, 0, 0x003F},
#endif
#ifdef BSP_DEVICE_NAME_PWM_B
		{ NULL, &PwmBDeviceContext, 1, 1, 0, 0x0001},
		{ NULL, &PwmBDeviceContext, 1, 2, 0, 0x0002},
		{ NULL, &PwmBDeviceContext, 1, 3, 0, 0x0004},
		{ NULL, &PwmBDeviceContext, 1, 4, 0, 0x0008},
		{ NULL, &PwmBDeviceContext, 1, 5, 0, 0x0000},
		{ NULL, &PwmBDeviceContext, 1, 6, 0, 0x0000},
		{ NULL, &PwmBDeviceContext, 2, 1, 0, 0x0003},
		{ NULL, &PwmBDeviceContext, 2, 3, 0, 0x000C},
		{ NULL, &PwmBDeviceContext, 2, 5, 0, 0x0030},
		{ NULL, &PwmBDeviceContext, 3, 1, 0, 0x0007},
		{ NULL, &PwmBDeviceContext, 3, 4, 0, 0x0038},
		{ NULL, &PwmBDeviceContext, 6, 1, 0, 0x003F},
#endif
		{ NULL, NULL, 0, 0, 0, 0}
	};

#endif /* INCLUDE_PWM */

/*****************************************************************************/
#if defined( INCLUDE_MSCAN )

    static UWord16 readBuf[CAN_RX_BUFFER_SIZE(CAN_RECEIVE_ID_QUEUE_SIZE) * CAN_MAX_RECEIVE_ID];
    static can_sWriteBuffer writeBuf[CAN_MAX_TRANSMIT_ID];

    const io_sMSCANInterface canInterfaceVT = {      
        canRead, 
        canWrite,         
        canClose, 
        {   ioctlCAN_GET_STATUS,ioctlCANID_GET_STATUS,
            ioctlCAN_RESET,ioctlCAN_SET_SLEEP,ioctlCAN_SET_WAKEUP
        } /* Ioctl */
    };
        
    const can_pRawCallBack CANRcvPrepare =   /*  RAW CallBack pointer */
    #if defined(CAN_RAW_CALLBACK)
		(can_pRawCallBack)CAN_RAW_CALLBACK;
    #else
        #if defined(CAN_RECEIVE_HANDLER_USES_PRAGMA_INTERRUPT)
            NULL;
        #else
            (can_pRawCallBack)CANStdRcvPrepare;
        #endif
    #endif  /* ifndef CAN_RAW_CALLBACK  */

    const can_sInitialState canInitialState = {   	
	    "CAN",
		(can_sReadBuffer *)&readBuf[0],
        (can_sReadBuffer *)&readBuf[CAN_RX_BUFFER_SIZE(CAN_RECEIVE_ID_QUEUE_SIZE) * CAN_MAX_RECEIVE_ID ],
        CAN_RX_BUFFER_SIZE(CAN_RECEIVE_ID_QUEUE_SIZE),
		(can_sWriteBuffer *)&writeBuf[0],
		(can_sWriteBuffer *)&writeBuf[CAN_MAX_TRANSMIT_ID],

    #if defined(CAN_RAW_CALLBACK)
		(can_pRawCallBack)CAN_RAW_CALLBACK,
    #else
        NULL,
    #endif  /* ifndef CAN_RAW_CALLBACK  */

		CAN_STOP_IN_WAIT_MODE << 5,
		CANCANE | (CAN_LOOP_BACK << 2) | (CAN_WAKE_UP_MODE << 1) | CAN_CLOCK_SOURCE,
		((CAN_SYNCH_JUMP_WIDTH - 1) << 6) | ( CAN_PRESCALER - 1 ),
		
		(CAN_SAMPLING << 7) | ( (CAN_TIME_SEGMENT2 - 1 ) << 4 ) | ( CAN_TIME_SEGMENT1 - 1 ),

		CAN_CUSTOM_FILTER_CODE,
		CAN_CUSTOM_FILTER_MASK,
           	CAN_ROUND2UP( CAN_RECEIVE_ID_QUEUE_SIZE ) - 1,

		CAN_TX_ERROR_ASSERT == CAN_ASSERT_WARNING ? CANTWRNIE |  CANTERRIF | CANBOFFIE
		: CAN_TX_ERROR_ASSERT == CAN_ASSERT_ERROR ? CANTERRIF | CANBOFFIE
		: CANBOFFIE

	};


#endif /* INCLUDE_MSCAN */

/*****************************************************************************/
#if defined( INCLUDE_FLEXCAN )

#if defined(INCLUDE_IO)
    const io_sFLEXCANInterface canInterfaceVT = {      
        flexcanRead, 
        flexcanWrite,         
        flexcanClose, 
        { ioctlCAN_GET_STATUS, ioctlCANID_GET_STATUS,
          ioctlCAN_RESET, ioctlCAN_SET_SLEEP, ioctlCAN_SET_WAKEUP,
        }, /* Ioctl */
    };
#else /* INCLUDE_IO */
    const io_sFLEXCANInterface canInterfaceVT = {      
        no_read, 
        no_write,         
        no_close, 
        { no_ioctl, no_ioctl,
          no_ioctl, no_ioctl, no_ioctl
        }, /* Ioctl */
    };
#endif /* INCLUDE_IO */

     const can_pRawCallBack CANRcvPrepare =   /*  RAW CallBack pointer */
    #if defined(CAN_RAW_CALLBACK)
		CAN_RAW_CALLBACK;
    #else
        NULL;
    #endif  /* ifndef CAN_RAW_CALLBACK  */
   
    const can_sInitialState canInitialState = {   	
        3,
    #if defined(CAN_RAW_CALLBACK)
		CAN_RAW_CALLBACK,
    #else
        NULL,
    #endif  /* ifndef CAN_RAW_CALLBACK  */

        /* FCMCR = */   0x5000 
                        | ( CAN_WAKE_UP_MODE << 6 ),
        /* FCCTL0 = */  0 
                        | ( CAN_SAMPLING << 7)
                        | ( CAN_LOOP_BACK << 6)
                        | ( CAN_PROP_SEGMENT - 1) ,
        /* FCCTL1 = */  0
                        | (( CAN_PRESCALER - 1 ) << 8)
                        | (( CAN_SYNCH_JUMP_WIDTH - 1) << 6)
                        | (( CAN_PHASE_SEGMENT1 - 1 ) << 3 ) 
                        | (  CAN_PHASE_SEGMENT2 - 1 )
	};

    const unsigned int FlexCANFlags = 0
#if defined( CAN20B )
                        | O_CAN_2B
#endif
#if  CAN_LOOP_BACK == 1
                        | O_LOOP_BACK
#endif /* defined( CAN_LOOP_BACK ) */
        ;  


#endif /* INCLUDE_FLEXCAN */

/*****************************************************************************/
#if defined( INCLUDE_COP )

	const unsigned int copPeriodMicroSeconds = ((COP_PRESCALER * 1000000UL) / BSP_OSCILLATOR_FREQ);

	const struct io_sCOPInterface COPInterfaceVT = {
		NULL,
		NULL,
		copClose,
		{
		ioctlCOP_RELOAD,
		ioctlCOP_GET_RESET_STATUS,
		ioctlCOP_CLR_RESET_STATUS
		} /* Ioctl */
	};

#endif 

/*****************************************************************************/
#if defined( INCLUDE_FILEIO )

    const struct io_sFileIOInterface fileioInterfaceVT = {      
        fileioRead, 
        fileioWrite,
        fileioClose,
        {ioctlFILEIO} /* Ioctl */
    };
        

#ifndef FILEIOFILESLIMIT
#define FILEIOFILESLIMIT 2
#endif

#if FILEIOFILESLIMIT > 10
#error No more then 10 files can be opened 
#endif

const int fileioFilesLimit = FILEIOFILESLIMIT;

struct fileio_Handle fileDriver[FILEIOFILESLIMIT];

#endif 


/*****************************************************************************/
#if defined( INCLUDE_SCI )
		
	#if defined(INCLUDE_IO)
	
		const struct io_sSCIInterface scidrvIOBlockInterfaceVT = 
		{
			sciBlockRead, sciBlockWrite, sciClose, SCI_IOCTLs
		};

		const struct io_sSCIInterface scidrvIONonBlockInterfaceVT = 
		{
			sciNonBlockRead, sciNonBlockWrite,sciClose,	SCI_IOCTLs
		};
	
	#else /* INCLUDE_IO */
	
		const io_sInterface scidrvIOBlockInterfaceVT = 
		{
			noSciBlockRead, noSciBlockWrite, noSciClose, noSciIoctl
		};

		const io_sInterface scidrvIONonBlockInterfaceVT = 
		{
			noSciNonBlockRead, noSciNonBlockWrite, noSciClose, noSciIoctl
		};
	#endif /* INCLUDE_IO */

  #if defined(BSP_DEVICE_NAME_SCI_0)
  
	struct sSciDevice Sci0DeviceContext = 
   	   {
   	      (io_sInterface *)&scidrvIONonBlockInterfaceVT,
          &ArchIO.Sci0,        	/* Base */
	   	  SCI_SCIDR_8BIT_MASK, 	/* Mask */
	   	  /* receive */
      	  {
           	0, 	/* begin */
           	0, 	/* marker*/
           	SCI0_RXBUF_MASK,	/* mask */
           	SCI0_RXBUF_OFFSET	/* buffer address */
      	  },
      	  /* send */
      	  {
           	0, 	/* begin */
           	0, 	/* marker*/
           	SCI0_TXBUF_MASK,	/* mask */
           	SCI0_TXBUF_OFFSET	/* buffer address */
      	  }
	   };
  #endif
  
  #if defined(BSP_DEVICE_NAME_SCI_1)   
  
	struct sSciDevice Sci1DeviceContext = 
   	   {
   	   (io_sInterface *)&scidrvIONonBlockInterfaceVT,
          &ArchIO.Sci1,       		 		/* Base */
      	  SCI_SCIDR_8BIT_MASK,              /* Mask */
      	  /*receive*/
      	  {
             0, 	/* begin */
             0, 	/* marker*/
             SCI1_RXBUF_MASK,	/* mask */
             SCI1_RXBUF_OFFSET	/* buffer address */
      	  },
      	  /*send*/
      	  {
             0, 				/* begin */
             0, 				/* marker*/
             SCI1_TXBUF_MASK,	/* mask */
             SCI1_TXBUF_OFFSET	/* buffer address */
      	  }
	   };
  #endif /* defined(BSP_DEVICE_NAME_SCI_1) */
#endif /* INCLUDE_SCI */

/*****************************************************************************/
#if defined( INCLUDE_DECODER )
        
        const io_sDecoderInterface decoderdrvIOInterfaceVT = {
        NULL,
        NULL,
        decoderClose,
        {
        decoderIoctlDEC_HOME_INTERRUPT_REQUEST_CLEAR,
        decoderIoctlDEC_INDEX_PULSE_INTERRUPT_REQUEST_CLEAR,
        decoderIoctlDEC_WATCHDOG_INTERRUPT_REQUEST_CLEAR,
        decoderIoctlDEC_WRITE_WATCHDOG_TIMEOUT,
        decoderIoctlDEC_READ_POSITION_DIFFERENCE,
        decoderIoctlDEC_READ_REVOLUTION,
        decoderIoctlDEC_WRITE_REVOLUTION,
        decoderIoctlDEC_READ_POSITION,
        decoderIoctlDEC_WRITE_POSITION,
        decoderIoctlDEC_WRITE_INIT_STATE,
        decoderIoctlDEC_READ_MONITOR_REG,
        decoderIoctlDEC_GET_RAW_ENCSIGNALS,
        decoderIoctlDEC_GET_FILTERED_ENCSIGNALS,
        decoderIoctlDEC_READ_CONTROL_REG,
        decoderIoctlDEC_CALCULATE_SCALE_COEF,
        decoderIoctlDEC_GET_SCALED_POSITION,
        decoderIoctlDEC_GET_SCALED_POSITION_DIFFERENCE,
        }
        };
        
        sDecoderDevice Decoder0DeviceContext =
        {
            (io_sInterface *)&decoderdrvIOInterfaceVT,
            0,
            0,
            0,
            0,
            0
        };
#endif /*  defined( INCLUDE_DECODER ) */

/*****************************************************************************/
#if defined( INCLUDE_GPIO )

        const io_sGPIOInterface gpiodrvIOInterfaceVT = {
        gpioRead,
        gpioWrite,
        gpioClose,
#if defined( GPIO_INLINE )
        NULL,
#else                
        {
        gpioIoctlGPIO_SET,
        gpioIoctlGPIO_CLEAR,
        gpioIoctlGPIO_TOGGLE,
        gpioIoctlGPIO_DISABLE_PULLUP,
        gpioIoctlGPIO_ENABLE_PULLUP,
        gpioIoctlGPIO_SETAS_INPUT,
        gpioIoctlGPIO_SETAS_OUTPUT,
        gpioIoctlGPIO_SETAS_GPIO,
        gpioIoctlGPIO_SETAS_PERIPHERAL,
        gpioIoctlGPIO_INTERRUPT_ASSERT_DISABLE,
        gpioIoctlGPIO_INTERRUPT_ASSERT_ENABLE,
        gpioIoctlGPIO_INTERRUPT_DISABLE,
        gpioIoctlGPIO_INTERRUPT_ENABLE,
        gpioIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_HIGH,
        gpioIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_LOW,
        gpioIoctlGPIO_CLEAR_INTERRUPT_PEND_REGISTER,
        gpioIoctlGPIO_READ
        }
#endif
    };


        const io_sGPIOInterface gpiopinInterfaceVT = {
        gpiopinRead,
        gpiopinWrite,
        gpiopinClose,
        {
        gpiopinIoctlGPIO_SET,
        gpiopinIoctlGPIO_CLEAR,
        gpiopinIoctlGPIO_TOGGLE,
        gpiopinIoctlGPIO_DISABLE_PULLUP,
        gpiopinIoctlGPIO_ENABLE_PULLUP,
        gpiopinIoctlGPIO_SETAS_INPUT,
        gpiopinIoctlGPIO_SETAS_OUTPUT,
        gpiopinIoctlGPIO_SETAS_GPIO,
        gpiopinIoctlGPIO_SETAS_PERIPHERAL,
        gpiopinIoctlGPIO_INTERRUPT_ASSERT_DISABLE,
        gpiopinIoctlGPIO_INTERRUPT_ASSERT_ENABLE,
        gpiopinIoctlGPIO_INTERRUPT_DISABLE,
        gpiopinIoctlGPIO_INTERRUPT_ENABLE,
        gpiopinIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_HIGH,
        gpiopinIoctlGPIO_INTERRUPT_DETECTION_ACTIVE_LOW,
        gpiopinIoctlGPIO_CLEAR_INTERRUPT_PEND_REGISTER,
        gpiopinIoctlGPIO_READ
        }
    };
    
    sGpioDevice pinPortAMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_A)
        	{
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_A) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

    sGpioDevice pinPortBMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_B)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_B) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

  
    sGpioDevice pinPortCMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_C)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_C) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            }
        };

    sGpioDevice pinPortDMap[] = 
        {
  #if defined(BSP_DEVICE_NAME_GPIO_D)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_D) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80                               /* Mask */
            }
        };

    sGpioDevice pinPortEMap[] = 
        {
   #if defined(BSP_DEVICE_NAME_GPIO_E)
            {
	        (io_sInterface *)&gpiodrvIOInterfaceVT,          
			0,								   /* Base */
        	0xFFFF                             /* Mask */
	        },
  #endif /* defined(BSP_DEVICE_NAME_GPIO_E) */
            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x01                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x02                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x04                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x08                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x10                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x20                               /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x40	                           /* Mask */
            },

            {
            (io_sInterface *)&gpiopinInterfaceVT,          
			0,								   /* Base */
            0x80	        			       /* Mask */
            }
        };


#endif /* defined( INCLUDE_GPIO ) */

/*****************************************************************************/

 

#if defined( INCLUDE_SWITCH )


	

	const struct io_sSwitchInterface switch_io_interface = {
		NULL,
		NULL,
		switchClose,
		switchIoctllSWITCH_GET_STATE
	};

	const struct switch_sConfig switchdrvDevice =
	{
	(io_sInterface*)&switch_io_interface, &ArchIO.PortD, 1<<5
	};
	


#endif /* INCLUDE_SWITCH */

#if defined( INCLUDE_BUTTON )
	
	const io_sInterface button_io_interface = {
		NULL,
		NULL,
		buttonClose,
		NULL
	};
#if defined(BSP_DEVICE_NAME_BUTTON_A)
	struct button_sButton ButtonADeviceContext =
		{(io_sInterface*)&button_io_interface,{0,0} };
#endif
#if defined(BSP_DEVICE_NAME_BUTTON_B)
	struct button_sButton ButtonBDeviceContext =
		{(io_sInterface*)&button_io_interface,{0,0} };
#endif
#endif /* INCLUDE_BUTTON */

/*****************************************************************************/
#if defined( INCLUDE_FLASH )

#if defined( INCLUDE_IO) 
    const io_sFlashInterface flash_io_interface = { 
        flashRead, flashWrite, flashClose, 
        {   
            ioctlFLASH_RESET, ioctlFLASH_MODE_VERIFY, ioctlFLASH_CMD_SEEK 
        }
    };
#endif /* INCLUDE_IO */
    
    struct sflashDesc PmemFlash =  {
#if defined( INCLUDE_IO) 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_PMEM, 
        ioctlFLASH_RAW_READ_PMEM, 
        ioctlFLASH_RAW_WRITE_PMEM,
        PMEM_FLASH_SIZE * sizeof(int) / PAGE_SIZE_P_IN_BYTES,  /* 128k words, dakar */
        /* PAGE_SIZE_P_IN_BYTES */ PAGE_SIZE_P_LOG + 1
    };

    struct sflashDesc XmemFlash = {
#if defined( INCLUDE_IO) 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_XMEM,
        ioctlFLASH_RAW_READ_XMEM,
        ioctlFLASH_RAW_WRITE_XMEM,
        XMEM_FLASH_SIZE * sizeof(int) / PAGE_SIZE_IN_BYTES, /* 8k dakar */
        /* PAGE_SIZE_IN_BYTES */ PAGE_SIZE_LOG + 1
    };

    struct sflashDesc BootFlash = {
#if defined( INCLUDE_IO) 
        &flash_io_interface,
#else /* INCLUDE_IO */
        0,
#endif /* INCLUDE_IO */
        ioctlFLASH_RAW_ERASE_BOOT, 
        ioctlFLASH_RAW_READ_BOOT, 
        ioctlFLASH_RAW_WRITE_BOOT,
        BOOT_FLASH_SIZE * sizeof(int) / PAGE_SIZE_IN_BYTES, /* 8k dakar */
       /* PAGE_SIZE_IN_BYTES */ PAGE_SIZE_LOG + 1
    };

    /* empirical formula for Flash divider */ 

#if PLL_MUL >= 31
#define FLASH_DIVIDER 19 /*	193.75 */
#elif PLL_MUL >= 30
#define FLASH_DIVIDER  18 /* 197.37 */
#elif PLL_MUL >= 28
#define FLASH_DIVIDER  17 /* 194.44 */
#elif PLL_MUL >= 26
#define FLASH_DIVIDER  16 /* 191.18 */
#elif PLL_MUL >= 25
#define FLASH_DIVIDER  15 /* 195.31 */
#elif PLL_MUL >= 23
#define FLASH_DIVIDER  14 /* 191.67 */
#elif PLL_MUL >= 21
#define FLASH_DIVIDER  13 /* 187.5 */
#elif PLL_MUL >= 20
#define FLASH_DIVIDER  12 /* 192.31 */
#elif PLL_MUL >= 18
#define FLASH_DIVIDER  11 /* 187.5 */
#elif PLL_MUL >= 17
#define FLASH_DIVIDER  10 /* 193.18 */
#elif PLL_MUL >= 15
#define FLASH_DIVIDER  9 /* 187.5 */
#elif PLL_MUL >= 13
#define FLASH_DIVIDER  9 /* 180.56 */
#elif PLL_MUL >= 12
#define FLASH_DIVIDER  7 /* 187.5 */
#elif PLL_MUL >= 9
#define FLASH_DIVIDER  6 /* 160.71 */
#elif PLL_MUL >= 7
#define FLASH_DIVIDER  4 /* 175 */
#elif PLL_MUL >= 5
#define FLASH_DIVIDER  3 /* 156.25 */
#elif PLL_MUL >= 4
#define FLASH_DIVIDER  2 /* 166.67 */
#else
#error incorrect PLL for flash programming
#endif 


/* configured prescaler value */
const unsigned int flash_divider = (0x40 | FLASH_DIVIDER );

#endif /* INCLUDE_FLASH */


/*****************************************************************************/
#if defined( INCLUDE_BLDC )

	#include "pwm.h"
	#include "bldcdrv.h"


    /*****************************************************************************/
    /** Commutation table for EMV Motor Kit and independed PWM mode				**/
    /*****************************************************************************/

    const mc_tPWMSignalMask   bldcCommutationTableInd[8] = { MC_PWM_ALL_SIGNALS,
    	 (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_0),
    	 (MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0),
    	 (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_0),
    	 (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1),
    	 (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0),
    	 (MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1),
    												          MC_PWM_ALL_SIGNALS
    													   };

    /*****************************************************************************/
    /** Commutation table for EMV Motor Kit and complementary PWM mode			**/
    /*****************************************************************************/

    const pwm_sChannelControl bldcCommutationTableComp[8] = {
                { MC_PWM_ALL_SIGNALS, 0 },
			    { (MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2), (PWM_SWAP_1 | PWM_SWAP_0) },
			    { (MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0), (PWM_SWAP_2 | PWM_SWAP_0) },
			    { (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4), (PWM_SWAP_0) },
			    { (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4), (PWM_SWAP_2 | PWM_SWAP_1) },
		        { (MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0), (PWM_SWAP_1) },
			    { (MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2), (PWM_SWAP_2) },
 			    { MC_PWM_ALL_SIGNALS, 0 },
				    										};


    /*****************************************************************************/
    /** Commutation table for sensorless control                                **/
    /**               EMV,LV,HV Motor Kits and independed PWM mode	            **/
    /*****************************************************************************/
    const mc_tPWMSignalMask  BldcZC_Cmt_StepTable[] = { 
           (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1),
           (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0),
           (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_0),
           (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_0),
           (MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0),
           (MC_PWM_SIGNAL_4 | MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2 | MC_PWM_SIGNAL_1)
                                                      };

    /*****************************************************************************/
    /** Commutation table for sensorless control                                **/
    /**               EMV,LV,HV Motor Kits and complementary PWM mode	        **/
    /*****************************************************************************/
    const pwm_sChannelControl  BldcZC_Cmt_StepTableComp [MAX_STEP_CMT+1] = {
                { (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4), (PWM_SWAP_2 | PWM_SWAP_1) },
                { (MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0), (PWM_SWAP_1) },
                { (MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2), (PWM_SWAP_1 | PWM_SWAP_0) },
                { (MC_PWM_SIGNAL_5 | MC_PWM_SIGNAL_4), (PWM_SWAP_0) },
                { (MC_PWM_SIGNAL_1 | MC_PWM_SIGNAL_0), (PWM_SWAP_2 | PWM_SWAP_0) },
                { (MC_PWM_SIGNAL_3 | MC_PWM_SIGNAL_2), (PWM_SWAP_2) }
                                                                           };



	/**************************************************************************************/
	/** Zero Crossing tables for sensorless Zero Crossing EMV,LV,HV Motor Kits PWM mode  **/
	/** for (level)Zero Crosing bldczc algorithms (used with HW comparator Zero Crossing)**/
	/**************************************************************************************/	

	const UWord16 Mask_ZCInpTab[MAX_STEP_CMT+1] = { MASK_ZC_PHASE_C, MASK_ZC_PHASE_A, MASK_ZC_PHASE_B,\
                                                MASK_ZC_PHASE_C, MASK_ZC_PHASE_A, MASK_ZC_PHASE_B };

	const UWord16 Expect_ZCInp_Tab [ MAX_STEP_CMT+1 ] [2] = \
	{ {ZCINP_PHASE_C_Lev1,ZCINP_PHASE_C_Lev0},{ZCINP_PHASE_A_Lev0,ZCINP_PHASE_A_Lev1},\
  	{ZCINP_PHASE_B_Lev1,ZCINP_PHASE_B_Lev0},{ZCINP_PHASE_C_Lev0,ZCINP_PHASE_C_Lev1},\
  	{ZCINP_PHASE_A_Lev1,ZCINP_PHASE_A_Lev0},{ZCINP_PHASE_B_Lev0,ZCINP_PHASE_B_Lev1} };

	/*************************************************************************************/
	/** Zero Crossing tables for sensorless Zero Crossing EMV,LV,HV Motor Kits PWM mode **/
	/** for edge Zero Crosing bldczc algorithms (used with ADC Zero Crossing)           **/
	/*************************************************************************************/

	const UWord16 SetADC_ZCInp_Tab [ MAX_STEP_CMT+1 ] [ 2 ] =
	{ {ADCZC_PHASE_C_NEG_POS,ADCZC_PHASE_C_POS_NEG},{ADCZC_PHASE_A_POS_NEG,ADCZC_PHASE_A_NEG_POS},\
	  {ADCZC_PHASE_B_NEG_POS,ADCZC_PHASE_B_POS_NEG},{ADCZC_PHASE_C_POS_NEG,ADCZC_PHASE_C_NEG_POS},\
	  {ADCZC_PHASE_A_NEG_POS,ADCZC_PHASE_A_POS_NEG},{ADCZC_PHASE_B_POS_NEG,ADCZC_PHASE_B_NEG_POS} };

	const Word16 ZC_Phase_Tab [] = { INDEX_ZC_PHASE_C, INDEX_ZC_PHASE_A, INDEX_ZC_PHASE_B, \
                                 INDEX_ZC_PHASE_C, INDEX_ZC_PHASE_A, INDEX_ZC_PHASE_B };
	const int Expect_ZCInpFlag_Tab [ MAX_STEP_CMT+1 ] [2] = \
	{ {1,0},{0,1},\
	  {1,0},{0,1},\
	  {1,0},{0,1} };
	 
#endif /* INCLUDE_BLDC */

/*****************************************************************************/
#if defined( INCLUDE_IO )
/* establish open array here */

#define IO_PACK( b1, b2, b3, b4, e1, e2 )   \
    ((unsigned long)b1 << 24) |             \
    ((unsigned long)b2 << 16) |             \
    ((unsigned long)b3 << 8) |              \
    ((unsigned long)b4),  { e1, e2}

typedef  handle_t (*openFunc) (const char *pName, int OFlags, ...);
const struct io_sDevice DeviceTable[] = {

#if defined( INCLUDE_LED )
	{ ledOpen, (int)BSP_DEVICE_NAME_LED_0,  },
	#if defined( INCLUDE_LED_PWM )
		{ledPWMOpen, (int)BSP_DEVICE_NAME_LED_PWM,   },
	#endif
#endif

#if defined( INCLUDE_GPIO )
    {gpioOpen , (int)BSP_DEVICE_NAME_GPIO_A },
    {gpioOpen , (int)BSP_DEVICE_NAME_GPIO_B },
    {gpioOpen , (int)BSP_DEVICE_NAME_GPIO_C },
    {gpioOpen , (int)BSP_DEVICE_NAME_GPIO_D },
    {gpioOpen , (int)BSP_DEVICE_NAME_GPIO_E }, 
#endif

#if defined( INCLUDE_DECODER )
    {decoderOpen , (int)BSP_DEVICE_NAME_DECODER_0 },
#endif

#if defined( INCLUDE_SCI )
    {(openFunc)sciPreOpen, (int)BSP_DEVICE_NAME_SCI_0,  },
    {(openFunc)sciPreOpen, (int)BSP_DEVICE_NAME_SCI_1,  },
#endif

#if defined( INCLUDE_MSCAN )
	{canOpen, (int)BSP_DEVICE_NAME_CAN_0 },
#endif

#if defined( INCLUDE_FLEXCAN )
    { flexcanPreOpen, (int)BSP_DEVICE_NAME_CAN_0 },
#endif /* defined( INCLUDE_FLEXCAN ) */


#if defined( INCLUDE_SPI )
	{spiOpen, (int)BSP_DEVICE_NAME_SPI_0 },
	{spiOpen, (int)BSP_DEVICE_NAME_SPI_1 },
#endif

#if defined( INCLUDE_ADC )
	{adcOpen, (int)BSP_DEVICE_NAME_ADC_A },
	{adcOpen, (int)BSP_DEVICE_NAME_ADC_B },
	{adcPinsOpen, (int)BSP_DEVICE_NAME_0_ADC_PIN },	
	{adcPinOpen, (int)BSP_DEVICE_NAME_AN_A_0 },	
	{adcPinOpen, (int)BSP_DEVICE_NAME_AN_B_0 },	
#endif

#if defined( INCLUDE_FILEIO )
//	    {, fileioOpen, },
#endif
#if defined( INCLUDE_COP )
    {copOpen, (int)BSP_DEVICE_NAME_COP },
#endif

#if defined( INCLUDE_PWM )
	{pwmOpen, (int)BSP_DEVICE_NAME_PWM_A },
    {pwmOpen, (int)BSP_DEVICE_NAME_PWM_B },
    {pwmChannelOpen, (int)BSP_DEVICE_NAME_PWM_Ax1_0 },
    {pwmChannelOpen, (int)BSP_DEVICE_NAME_PWM_Bx1_0 },
#endif

#if defined( INCLUDE_DAC )
	{dacOpen, (int)BSP_DEVICE_NAME_DAC_A },
	{dacOpen, (int)BSP_DEVICE_NAME_DAC_B },
	{dacOpen, (int)BSP_DEVICE_NAME_DAC_C },
	{dacOpen, (int)BSP_DEVICE_NAME_DAC_D },
#endif

#if defined( INCLUDE_SWITCH )
	{switchOpen, (int)BSP_DEVICE_NAME_SWITCH_0 },
#endif

#if defined( INCLUDE_BUTTON )
	{buttonOpen, (int)BSP_DEVICE_NAME_BUTTON_A },
	{buttonOpen, (int)BSP_DEVICE_NAME_BUTTON_B },
#endif

#if defined( INCLUDE_FLASH )    
	{flashPmemOpen, (int)BSP_DEVICE_NAME_FLASH_PMEM },
	{flashXmemOpen, (int)BSP_DEVICE_NAME_FLASH_XMEM },
	{flashBootOpen, (int)BSP_DEVICE_NAME_FLASH_BOOT },
#endif /* defined( INCLUDE_FLASH ) */

    	{ no_open, 0  }     /* error handler */

};

const int DeviceTableLen = sizeof(DeviceTable) / sizeof(DeviceTable[0]) - 1;

#endif /* INCLUDE_IO */


/* Structure to save/restore peripheral registers power on reset state */

#if 0

arch_PeriphRegState peripheralReg[archoff_registers_num] = {
	{archoff_FlexCAN + BSP_PERIPH_BASE, archoff_FlexCAN_length},
	{archoff_PortA  + BSP_PERIPH_BASE, archoff_PortA_length},
	{archoff_Sci0  + BSP_PERIPH_BASE, archoff_Sci0_length},
	{archoff_Sci1  + BSP_PERIPH_BASE, archoff_Sci1_length},
	{archoff_TimerA0  + BSP_PERIPH_BASE, archoff_TimerA0_length},
	{archoff_TimerB0 + BSP_PERIPH_BASE, archoff_TimerB0_length},
	{archoff_TimerC0 + BSP_PERIPH_BASE, archoff_TimerC0_length},
	{archoff_TimerD0 + BSP_PERIPH_BASE, archoff_TimerD0_length},
	{archoff_Flash  + BSP_PERIPH_BASE, archoff_Flash_length}
};


UWord16  RegState[archoff_FlexCAN_length + archoff_PortA_length + archoff_Sci0_length + \
    					archoff_Sci1_length + archoff_TimerA0_length + archoff_TimerB0_length + \
    					archoff_TimerC0_length + archoff_TimerD0_length + archoff_Flash_length]  ;


#endif