#include "bsp.h"
#include "periph.h"


#if defined (DSP56832XEVM)

#include "832xappconst.h"

#else 

#ifdef DSP56835XEVM

#include "835xappconst.h"

#elif defined (DSP56836XEVM)

#include "836xappconst.h"

#else

#include "834xappconst.h"

#endif

#endif

int checkArray (void* arrAdd, unsigned int arrLen);

extern void * _begin_addr_in_pFlashConst;
extern void * _begin_addr_in_xFlashConst;

#define BOOT_START_DELAY 10
#define BOOT_VERSION_PROMPT 0xFF

#pragma define_section bootcfg_section "appconst.data" R
#pragma section bootcfg_section begin
const unsigned short Cfg_StartDelay = (BOOT_VERSION_PROMPT << 8) | BOOT_START_DELAY;
#pragma section bootcfg_section end

void main ()
{
    UWord32  I;
    int      Passed   = 1;
    int      Passed1  = 1;
    int      PassedTemp  = 1;
    int      PassedTemp1 = 1;
    int      PassedTemp2 = 1;
	handle_t LedGreen;
	handle_t LedRed;
	handle_t Led0;

#if defined (DSP56832XEVM)

	periphMemWrite(0x0000,(volatile unsigned short *)0xF2E3);
	periphMemWrite(0xFFFF,(volatile unsigned short *)0xF2E2);
	periphMemWrite(0x0000,(volatile unsigned short *)0xF2E1);
   	
   	periphMemWrite(0x0000,(volatile unsigned short *)0xF303);
	periphMemWrite(0xFFFF,(volatile unsigned short *)0xF302);
	periphMemWrite(0x0000,(volatile unsigned short *)0xF301);
   	
#else 

	periphMemWrite(0x0000,(volatile unsigned short *)0xF313);
	periphMemWrite(0xFFFF,(volatile unsigned short *)0xF312);
	periphMemWrite(0x0000,(volatile unsigned short *)0xF311);
   	
   	periphMemWrite(0x0000,(volatile unsigned short *)0xF323);
	periphMemWrite(0xFFFF,(volatile unsigned short *)0xF322);
	periphMemWrite(0x0000,(volatile unsigned short *)0xF321);

#endif

#ifdef DSP56835XEVM  	
    Passed = checkArray (&_begin_addr_in_pFlashConst, ARRAYDATA_LENGTH/2);

    PassedTemp = checkArray ((void *)(0x100DB), ARRAYDATA_LENGTH/2);
    
    Passed = Passed & PassedTemp;

#elif defined (DSP56836XEVM)

 	Passed = checkArray (&_begin_addr_in_pFlashConst, ARRAYDATA_LENGTH/4);

    PassedTemp = checkArray ((void *)(0x10135), ARRAYDATA_LENGTH/4);
    
    PassedTemp1 = checkArray ((void *)(0x200C8), ARRAYDATA_LENGTH/4);
    
    PassedTemp2 = checkArray ((void *)(0x3005B), ARRAYDATA_LENGTH/4);
    
    Passed = Passed & PassedTemp & PassedTemp1 & PassedTemp2;

#else 

    Passed = checkArray (&_begin_addr_in_pFlashConst, ARRAYDATA_LENGTH);

#endif
    
    Passed1 = 1;
    
    for (I = 0; I < ARRAYDATA_LENGTH1; I++)
    {
        if (arrayData1[I] != I)
        Passed1 = 0;
    }
  
    if (Passed == 1 && Passed1 == 1)
    {

        while (1)
        {
#if defined (DSP56832XEVM)
  	        periphMemWrite(0x0020,(volatile unsigned short *)0xF2E1);
#else
	        periphMemWrite(0x0004,(volatile unsigned short *)0xF311);
#endif
	        for(I = 0; I < 0x30000; I++)
	        {
	           asm( nop );
	           asm( nop );
	           asm( nop );
	        }
	        
#if defined (DSP56832XEVM)

	        periphMemWrite(0x0000,(volatile unsigned short *)0xF2E1); 
	       
#else	       
			periphMemWrite(0x0000,(volatile unsigned short *)0xF311);
	        
#endif	        
	        for(I = 0; I < 0x30000; I++)
	        {
	           asm( nop );
	           asm( nop );
	           asm( nop );
	        }
		}
	}
    else
    {
        while (1)
        {
#if defined (DSP56832XEVM)

       		periphMemWrite(0x0001,(volatile unsigned short *)0xF2E1);
       		
#else       		
       		periphMemWrite(0x0001,(volatile unsigned short *)0xF311);      
	       
#endif	       
	       
	        for(I = 0; I < 0x30000; I++)
	        {
	           asm( nop );
	        }
	        
#if defined (DSP56832XEVM)
	        
	        periphMemWrite(0x0000,(volatile unsigned short *)0xF2E1); 
#else 	       
 	      
 	       	periphMemWrite(0x0000,(volatile unsigned short *)0xF311);     
#endif	        
	        
	        for(I = 0; I < 0x30000; I++)
	        {
	           asm( nop );
	        }
		}

    }

    return;
}

int checkArray (void* arrAdd, unsigned int arrLen)
{
	asm (lsra    R2); 
//	asm (lsr.w   Y0); 
	asm (clr.w   X0);
	asm (do      Y0,EndDoEven); 
			
	asm (move.w P:(R0)+,Y0);
	asm (cmp.w X0, Y0);
	asm (bne ArrayNotEq);
	asm (inc.w 	X0);
	
	asm (nop);
	asm (nop);
EndDoEven:
	asm (move.w #1, Y0);
	asm (rts);

ArrayNotEq:
	asm (move.w #0, Y0);
	asm (rts);
	
}
